;(function (){
    var views = {}, moving = false; touchmove = "ontouchmove" in window ? "touchmove" : "mouseup";
    if(touchmove == "touchmove"){
        $(window).off("touchstart").on("touchstart", function(){
            moving = false;
        });
        $(window).off("touchmove").on("touchmove", function(){            
            moving = true;
        });
    }
    views.baseView = Backbone.View.extend({
        initialize: function(ops, navIndex){
            $(".loading").hide();
            this.initEvents();
            this.delegateEvents(this.events);
            this.init(ops, navIndex);            
        },
        initEvents: function(){},
        init: function(){},
        tap: ("ontouchstart" in window && isApp != "ios" && navigator.userAgent.indexOf("mac") == -1) ? "touchend" : "click",        
        listenToEvents: function($target, ev, callback){  
            $target.off(ev).on(ev, $.proxy(function(e){
                if(ev == "touchend" || ev == "click"){
                    var $this = this;               
                    function doEvent(){                  
                        if(!moving){
                            callback.call($this, e);
                        }                         
                    }
                    doEvent(); 
                }else{
                    callback.call(this, e);
                }
            }, this));
        }
    })
    //列表
    views.List = views.baseView.extend({
        tagName: "ul",
        template: _.template(htmls.list.join("")),
        offset: 0,
        init: function(ops, navIndex){
            $(".list .more").siblings("ul").hide();
            $(".main-content:nth(" + navIndex + ") > div").hide();        
            if(this.isEnd){
                $(".list .more span").hide();
            }else{
                $(".list .more span").show();
            }
            this.insertEL();
            this.$el.parent().show();
            $(".list .more span").off().on(this.tap, $.proxy(function(e){
                var t = {}, type = $(e.target).parents(".main-content").prev().find(".nav-list li.active").index() + 1;
                t = JSON.stringify(_.extend(t, paramObj, {type: type}));
                t = _.AESmodel().encryptURI(t);
                if(isApp === "android"){
                    window.demo.saveParams("list.html", ['t=', t, "&cn=", SCAddress].join(""))
                    // window.open();
                }else {
                    window.open("list.html?t=" + t + "&cn="+SCAddress);
                }  
            }, this));
            if(!_.isObject(ops)){redrawWebviewHeight(); return;}
            this.ops = ops;
            this.getNews(ops, this.offset);
        },
        insertEL: function(){
            if($(".list .more").siblings("ul." + this.className).length < 1){
                this.$el.insertBefore(".list .more");
                this.$el.show();
                return;
            }
            if(this.$el.find("li").length < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.$el.show();
        },
        getNews: function(ops){},
        getDetail: function(e){
            var $target = $(e.target);
            if(!$target.is("li")) $target = $target.parents("li");
            var id = $target.attr("data-cid");
            /*var comefrom = $target.attr("data-come");*/
            var t = {}, type = $target.parents(".main-content").prev().find(".nav-list li.active").index() + 1;
            t = JSON.stringify(_.extend(t, paramObj, {id: id, type: type/*, comefrom: comefrom*/}));
            t = _.AESmodel().encryptURI(t);
            if(isApp === "android"){
                window.demo.saveParams("article_detail.html", ['t=', t, "&cn=", SCAddress].join(""))
                // window.open("article_detail.html");
            }else {
                window.open("article_detail.html?t=" + t + "&cn="+SCAddress);
            }
        },
        dealMore: function(l){
            if(l < this.ops.Size){
                this.isEnd = true;
                $(".list .more span").hide();
            }
        },

        afterFillup: function(){
            redrawWebviewHeight();
            if((this.$el.find("li").length) < 1){
                this.$el.html('<li style="text-align: center; margin-top: 1em;">无相关数据</li>');
                // waaindow.ShortTips.install("数据记录为0条");
                return;
            }
            this.listenToEvents(this.$el.find("li"), this.tap, this.getDetail);
        }
    })

    //导航菜单
    views.Navs = views.baseView.extend({
        className: "main",
        currentPage: 1,
        focusArray: [],
        viewsArray: [],
        init: function(){
            //配置nav列表
            var navs = config.navs[0], l = navs.length, i, $navs, $tmphtml, $ultmp, $navfocus, j;
            if($(".main .nav").length > 0){
                return; 
            }
            this.$el.html("").insertAfter(".header");
            for(i = 0; i < l; i++){
                $navs = $('<div class="nav color-normal bg-nav l-h25 m-font nav-font nav-color"></div>');
                this.$el.append($navs).append('<div class="main-content"></div>');
                $tmphtml = $('<div class="nav-show bottom-color nav-bottom-style"></div>'),
                $ultmp = $('<ul class="nav-list flex"></ul>'), $navfocus = $('<div class="nav-focus bg-focus bottom-color2 nav-focus-bottom"></div>');
                $tmphtml.appendTo($navs).append($navfocus).append($ultmp);
                for(j = navs[i].startAt; j <= navs[i].endAt; j++){
                    $ultmp.append('<li class="box_flex_1 center b-font" data-index="' + i + '"><span>' + config.navs[j].name + '</span></li>');
                }
                $ultmp.find("li").width(1/navs[i].size * 100 + "%");
                $navfocus.width(1/navs[i].size * 100 + "%").height($tmphtml.height() - 1);                        
                if(i == 0){
                    $(".main-content:nth(0)", this.$el).html('<div class="list m-font"><div class="more right l-h25"><span>点击查看更多</span></div></div>');                    
                }
                this.showList($($ultmp.find("li")[0]));  
                $tmphtml = "";$ultmp = "";$navfocus = "";$navs = "";  
            }                
            this.listenToEvents($(".nav-show ul.nav-list li"), this.tap, function(e){
                var $target = $(e.target); 
                !$target.is("li") && ($target = $target.parents("li")); 
                if($target.is(".active")){return}     
                this.showList($target);
            });          
        },

        showList: function($e){
            var index = $e.index(), navIndex = $e.attr("data-index"), navs = config.navs, 
                navsObj = navs[0], size = navsObj[navIndex].size, $this = this, $el = $this.$el;
            Net.Log($(".nav-list:nth(" + navIndex + ") li.active", $el).removeClass("active").text());
            $e.addClass("active");
            $(".nav-focus:nth(" + navIndex + ")").animate({left: index/size * 100 + "%"}, 200);
            var viewIndex = index + navsObj[navIndex].startAt, navWrap = navs[viewIndex], ops = navWrap.ops;
            if(this.focusArray.indexOf(viewIndex) > -1){
                this.viewsArray[$this.focusArray.indexOf(viewIndex)].initialize(ops, navIndex);
            }else{  
                $(".main-content:nth(" + navIndex + ") > div").hide();            
                if(!navWrap.view){
                    if(navIndex == 0){
                        $(".list .more").siblings("ul").hide();
                        $(".list .more span").hide();
                    }
                    function showTip(){
                        var tips = window.ShortTips.install("栏目正在开发中，敬请期待！");
                        if(tips)
                        {
                            tips.$el.appendTo(".main-content:nth(" + navIndex + ")");
                        }else{
                            setTimeout(showTip, 100);
                        }
                    }
                    showTip();
                    return;
                }
                $this.focusArray.push(viewIndex);
                $this.viewsArray.push(new views[navWrap.view](ops, navIndex))
            }
        }
    })

    views.News = views.List.extend({
        className: "news",
        getNews: function(ops, offset){
            Net.NewsTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            this.$el.html("");
            var datas = (data && data.NewsTitile && data.NewsTitile[0])||[] ,l = datas.length, i;
            offset = offset || 0;
            this.dealMore(l);
            for(i = offset; i < l; i++){
                var datetime = datas[i].Time;
                var date = datetime.substring(0, datetime.indexOf(" "));
                var time = datetime.substring(datetime.indexOf(" ") + 1);
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].ID;/* datas[i].comefrom =  datas[i].Author || "";*/
                this.$el.append(this.template(datas[i]));
            }
            this.afterFillup();
        }
    })

    views.Notices = views.List.extend({
        className: "notices",
        getNews: function(ops, offset){               
            Net.BulletinTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            // console.log("返回数据：", data);
            this.$el.html("");
            offset = offset || 0;
            var datas = (data && data.BulletinTitile && data.BulletinTitile[0])||[] ,l = datas.length, i;
            this.dealMore(l);
            for(i = offset; i < l; i++){
                datas[i].Title = datas[i].BulletinTitle;
                var datetime = datas[i].PublishDate, date = datetime.substring(0, datetime.indexOf(" ")), time = datetime.substring(datetime.indexOf(" ") + 1, datetime.indexOf("."));
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].ID;/* datas[i].comefrom =  datas[i].CategoryName || "";*/
                this.$el.append(this.template(datas[i]));
            }
            this.$el.find(".time").hide();
            this.afterFillup();
        }
    })

    views.Reports = views.List.extend({
        className: "reports",
        getNews: function(ops, offset){
            Net.BSCTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            this.$el.html("");
            offset = offset || 0;
            var datas = (data && data.BSCTitle && data.BSCTitle[0])||[] ,l = datas.length, i;
            this.dealMore(l);
            for(i = offset; i < l; i++){
                var datetime = datas[i].Time, date = datetime.substring(0, datetime.indexOf(" ")), time = datetime.substring(datetime.indexOf(" ") + 1, datetime.indexOf("."));
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].GUID;/* datas[i].comefrom =  datas[i].OrgName || "";*/ 
                if(!datas[i].OrgName){
                    datas[i].Title = datas[i].Title;
                }else{
                    datas[i].Title = "【" + datas[i].OrgName + "】" + datas[i].Title;
                }   
                this.$el.append(this.template(datas[i]));
            }
            this.$el.find(".time").hide();
            this.afterFillup();
        }
    })

    //个股诊断
    views.Diagnosis = views.baseView.extend({
        className: "diagnosis",
        init: function(ops, navIndex){    
            $(".main-content:nth(" + navIndex + ") > div").hide();   
            var flag = false, deferr1;            
            if($(".main-content .diagnosis").length < 1){ 
                flag = true;
                this.$el.html(htmls.diag.join("")).appendTo(".main-content:nth(" + navIndex + ")");
                deferr1 = this.getGrade(ops);               
            }
            if($(".more", this.$el).length < 1){
                $('<div class="more right l-h25"><span>点击查看更多</span></div>').insertAfter(".research-wrap"); 
                $(".data-graph-wrap", this.$el).hide();              
            }
            this.listenToEvents($(".more", this.$el), this.tap, function(e){
                var t = {}, type = $(e.target).parents(".main-content").prev().find(".nav-list li.active").index() + 1;
                t = JSON.stringify(_.extend(t, paramObj, {type: type}));
                t = _.AESmodel().encryptURI(t); 
                if(isApp === "android"){
                    window.demo.saveParams('list.html', ['t=', t, "&cn=", SCAddress].join(""))
                    // window.open("list.html");
                }else {
                    window.open("list.html?t=" + t + "&cn="+SCAddress);
                }                        
            });    
            this.$el.show();
            if(flag){
                $.when(deferr1).done(redrawWebviewHeight);
            }else{
                redrawWebviewHeight();
            }   
        },
        //等级评级
        getGrade: function(ops){
            var $this = this;
            return Net.Grade(ops, function(data){ 
                try{
                    if(!data.Grade[0][0]){
                        window.ShortTips.install("查询数据为空");
                        return false; 
                    }
                }catch(e){
                    window.ShortTips.install("查询数据为空");
                    return false;
                }          
                var datas = (data && data.Grade && data.Grade[0] && data.Grade[0][0]) || {}
                datas.FZKJ = "--";datas.date = datas.Chg_dt && datas.Chg_dt.replace(/-/, "").replace(/-/, ".").substring(4, 9);               
                $this.$el.find(".research-wrap").html(_.template(htmls.diag_research.join(""))(
                    _.extend({}, {date: "--", QLMRRS: "--", MRRS: "--", GWRS: "--", SDJCRS: "--", MCRS: "--", ZHPJ: "--", JGCG: "--", JTPM: "--", ZHMBJ12: "--", Now: "--", ZGB: "--"}, datas)
                ));
                var star = parseFloat(datas.Star) || 0, floorStar, prestar = parseFloat(datas.Pre_Star) || 0, preFloorStar,
                    starWrap = $(".lastestreport"), preStarWrap = $(".lastreport"); 
                star < 0 && (star = 0), star > 5 && (star = 5), floorStar = Math.floor(star);
                prestar < 0 && (prestar = 0), prestar > 5 && (prestar = 5), preFloorStar = Math.floor(star);      
                if(floorStar < star){starWrap.find(".star-five:eq(" + floorStar + ")").addClass("half");}
                starWrap.find(".star-five:gt(" + floorStar + ")").addClass("disable");   
                if(preFloorStar < prestar){preStarWrap.find(".star-five:eq(" + preFloorStar + ")").addClass("half");}
                preStarWrap.find(".star-five:gt(" + preFloorStar + ")").addClass("disable"); 
                function setPosition(){
                    var min = 15, max = 85,
                        tmpdatas = ["强力买入", "买入", "观望", "适度减持", "卖出"], dw = $this.$el.find(".grade-entry-wrap .grade-entry").width();
                    if($("body").width() > 425){
                        min = 10; max = 90;
                    }
                    $this.$el.find(".grade-entry-wrap").css({"left":Math.min(Math.max((tmpdatas.indexOf(datas.ZHPJ || "观望") * 20 + 10), min), max) + "%", "margin-left": (0 - dw) / 2});  
                }
                setPosition();   
            });
        }       
    })

    //公司简介
    views.Company = views.baseView.extend({
        className: "company normal-font",
        init: function(ops, navIndex){
            $(".main-content:nth(" + navIndex + ") > div").hide(); 
            var flag = false, deferr1, deferr2, deferr3;  
            if($(".main-content .company").length < 1){
                flag = true;
                this.$el.html(_.template(htmls.company)(this.packageTitle())).appendTo(".main-content:nth(" + navIndex + ")");
                deferr1 = this.brief(ops);
                deferr2 = this.major(ops);
                deferr3 = this.bonus(ops);
            } 
            this.$el.show();
            if(flag){
                $.when(deferr1, deferr2, deferr3).done(redrawWebviewHeight);
            }else{
                redrawWebviewHeight();
            }     
        },

        packageTitle: function(){
            return {data: [
                {mainTitle: "公司简介", subTitle: "", className: "brief-content"},
                {mainTitle: "主营收入构成", subTitle: "单位：亿元", className: "major-content"},
                {mainTitle: "分红送配", subTitle: "", className: "bonus-content"}
            ]}
        },

        brief: function(ops){
            var $this = this;
            return Net.Company(ops, function(data){
                // console.log("公司简介：", data);
                var datas = (data && data.Company && data.Company[0] && data.Company[0][0]) || {};
                var formatData = $this.packageK_V(datas), l = formatData.length, html="";
                if(l < 1){
                    html = "无";
                }else{
                    var tpl =_.template(htmls.company_intro.join(""));
                    html="";
                    for(var i = 0; i < l; i++){
                        html += tpl(formatData[i]);
                    }
                }             
                $this.$el.find(".brief-content").html(html);
            });       
        },

        major: function(ops){
            var $this = this;
            return Net.MainOperIncome(ops, function(data){
                // console.log("主营收入组成", data);
                var datas = (data && data.MainOperIncome && data.MainOperIncome[0]) || [];
                var formatData = $this.packageMajor(datas), l = formatData.length, html="";
                if(l < 1){
                    html = "无";
                }else{
                    tpl =_.template(htmls.company_intro.join(""));
                    html=""; 
                    for(var i = 0; i < l; i++){
                        html += tpl(formatData[i]);
                    }
                }         
                
                $this.$el.find(".major-content").html(html);
            });
        },

        bonus: function(ops){
            var $this = this;
            return Net.Dividend(ops, function(data){
                // console.log("分红配送：", data)
                var datas = (data && data.Dividend && data.Dividend[0]) || [];
                var formatData = $this.packageBonus(datas), l = formatData.length, html="";
                if(l < 2){
                    html = "无";
                }else{
                    var tpl =_.template(htmls.company_bonus.join(""));
                    html=""; 
                    for(var i = 0; i < l; i++){
                        html += tpl(formatData[i]);
                    }
                }
                $this.$el.find(".bonus-content").html(html);
            })
        },

        packageMajor: function(data){
            var datas = [];
            for(var i = 0, l = data.length; i < l; i++){
                datas.push({key: data[i].BusinessContent || "--", value: _.f_numical(data[i].MainOperIncome)})
            }
            return datas;
        },

        packageBonus: function(data){
            var datas = [];
            datas.push({
                key: "年度", value: "方案", text: "除权日"
            });
            for(var i = 0, l = data.length; i < l; i++){
                datas.push({
                    key: _.f_date(data[i].DividendYear, "YYYY"), value: (data[i].DMDAdvanceStatement && data[i].DMDAdvanceStatement.replace(/\(含税\)/g, "")) || "--", text: _.f_date(data[i].ExRightDate)
                })
            };
            return datas;
        },    

        packageK_V: function(data){
            return[{
                key: "公司名称：", value: data.CompanyChiName || "--"
            }, {
                key: "上市日期：", value: _.f_date(data.ListDate)
            }, {
                key: "发行价格：", value: _.f_numical(data.IssuePriceRMB) + "元"
            }, {
                key: "发行数量：", value: _.f_numical(data.IssueVol) + "股"
            }, {
                key: "所属地区：", value: data.Province || "--"
            }, {
                key: "所属行业：", value: data.Industry || "--"
            }, {
                key: "主营业务：", value: data.MainBusiness || "--"
            }]
        }
    })

    //股东结构
    views.Shareholder = views.baseView.extend({
        className: "shareholder normal-font",
        init: function(ops, navIndex){
            // console.log("navIndex", navIndex);
            var flag = false, deferr1, deferr2, deferr3;
            $(".main-content:nth(" + navIndex + ") > div").hide();  
            if($(".main-content .shareholder").length < 1){  
                flag = true;
                this.$el.html(htmls.shareholder.join("")).appendTo(".main-content:nth(" + navIndex + ")");
                deferr1 = this.stock(ops);
                deferr2 = this.stocker(ops);
                deferr3 = this.stocking(ops);
            }
            this.$el.show();
            if(flag){
                $.when(deferr1, deferr2, deferr3).done(redrawWebviewHeight);
            }else{
                redrawWebviewHeight();
            }
        },

        stock: function(ops){
            var $this = this;
            return Net.ShareStru(ops, function(data){
                // console.log("股东：", data);
                var datas = (data && data.ShareStru && data.ShareStru[0] && data.ShareStru[0][0]) || {};
                var formatData = $this.packageStock(datas), tpl =_.template(htmls.company_intro.join("")), html=""; 
                for(var i = 0, l = formatData.length; i < l; i++){
                    html += tpl(formatData[i]);
                }
                $this.$el.find(".stock-content").html(html);
            })            
        },

        stocker: function(ops){
            var $this = this;
            return Net.NegotialeShareHolder(ops, function(data){
                // console.log("流通股东：", data)
                var datas = (data && data.NegotiableShareHolder && data.NegotiableShareHolder[0]) || [];
                var formatData = $this.packageStocker(datas), tpl =_.template(htmls.shareholder_stocker.join("")), html=""; 
                for(var i = 0, l = formatData.length; i < l; i++){
                    html += tpl(formatData[i]);
                }
                $this.$el.find(".stocker-content").html(html);
                var datetime = (datas[0] && datas[0].PublDate) || "";
                $this.$el.find(".stocker-date").html(_.productQuarterReport(datetime))
            })
        },

        stocking: function(ops){
            var $this = this;
            return Net.StockPortfolioDetail(ops, function(data){
                // console.log("基金持股：", data)
                var datas = (data && data.StockPortfolioDetail && data.StockPortfolioDetail[0]) || [];
                var formatData = $this.packageStocking(datas), tpl =_.template(htmls.shareholder_stocker.join("")), html=""; 
                for(var i = 0, l = formatData.length; i < l; i++){
                    html += tpl(formatData[i]);
                }
                $this.$el.find(".stocking-content").html(html);
                var datetime = (datas[0] && datas[0].PublDate) || "";
                $this.$el.find(".stocking-date").html(_.productQuarterReport(datetime))
            })
        },

        packageStocker: function(data){
            var datas = [];
            datas.push({key: "股东", value: "占比(%)", text: "变动"});
            for(var i = 0, l = data.length; i < l; i++){
                datas.push({
                    key: data[i].SHName || "--", value: _.f_numical(data[i].HoldRatio), text: data[i].Changed || "--"
                })
            }
            return datas;
        },

        packageStock: function(data){
            var diff = data.SHNum - data.Pre_SHNum;
            console.log((data.TotalShares * 10000));
            return [{
                key: "总股本", value: _.f_numical(((data.TotalShares && data.TotalShares.replace(/,/g, "")) * 10000) || 0) + "股"
            }, {
                key: "流通A股", value: _.f_numical(((data.AShares && data.AShares.replace(/,/g, "")) * 10000) || 0) + "股"
            }, {
                key: "股东人数", value: _.f_numical(data.SHNum || 0) + "户<br/>(较上期" + (diff == 0 ? "未变" : ((diff > 0 ? "增加": "减少") + _.f_numical(Math.abs(diff)))) + ")"
            }, {
                key: "人均持股", value: _.f_numical(data.AverageHoldSum || 0) + "股"
            }]
        },
        packageStocking: function(data){
            var datas = [];
            datas.push({key: "股东", value: "占比(%)", text: "变动"});
            for(var i = 0, l = data.length; i < l; i++){
                datas.push({
                    key: data[i].SHName || "--", value: _.f_numical(data[i].HoldRatio), text: data[i].Changed || "--"
                })
            }
            return datas;       
        }
    });

    //财务指标
    views.Financial = views.baseView.extend({
        className: "finance normal-font",
        currentPage: 1,
        init: function(ops, navIndex){
            var $this = this, flag = false, deferr;
            $(".main-content:nth(" + navIndex + ") > div").hide();  
            if($(".main-content .finance").length < 1){
                flag = true;
                this.$el.html(htmls.finance.join("")).appendTo(".main-content:nth(" + navIndex + ")");
                deferr = Net.BriefOf(ops, function(data){
                    // console.log("财务指标：", data);
                    var datas = (data && data.ProceFinanc && data.ProceFinanc[0]) || [];
                    
                    if(!datas.length){
                        window.ShortTips.install("查询数据为空");
                        return;
                    }
                    $this.profit(datas);
                    $this.debt(datas);
                    $this.cash(datas);
                });
            } 
            this.$el.show();
            if(flag){
                $.when(deferr).done(redrawWebviewHeight);
            }else{
                redrawWebviewHeight();
            }
            this.listenToEvents(this.$el.find(".finance-wrap"), this.tap, function(e){
                var t = {}; 
                t = JSON.stringify(_.extend(t, paramObj, {type: $(e.target).parents(".finance-wrap").index() + 1}));
                t = _.AESmodel().encryptURI(t);
                if(isApp === "android"){
                    window.demo.saveParams('finance_detail.html', ['t=', t, "&cn=", SCAddress].join(""))
                    // window.open("finance_detail.html");
                }else {
                    window.open("finance_detail.html?t=" + t + "&cn="+SCAddress);
                }  
            }); 
        }, 

        profit: function(data){
            var $this = this;
            var datas = data;
            // console.log("财务指标：", datas)

            var formatData = $this.packageProfit(datas), tpl =_.template(htmls.listArtiContent.join("")), html="";            
            for(var i = 0, l = formatData.length; i < l; i++){
                html += tpl({datas: formatData[i]});
            }
            $this.$el.find(".profit-content").html(html).prev().find(".sub-title").html(_.productQuarterReport(datas[0].Income_Date));      
        },

        debt: function(data){
            var $this = this;
            var datas = data;
            // console.log("财务指标debt：", datas)
            var formatData = $this.packageDebt(datas), tpl =_.template(htmls.listArtiContent.join("")), html=""; 
            for(var i = 0, l = formatData.length; i < l; i++){
                html += tpl({datas: formatData[i]});
            }
            $this.$el.find(".debt-content").html(html).prev().find(".sub-title").html(_.productQuarterReport(datas[0].Balance_Date)); 
        },

        cash: function(data){
            var $this = this;
            var datas = data;
             // console.log("财务指标cash：", datas)
            var formatData = $this.packageCash(datas), tpl =_.template(htmls.listArtiContent.join("")), html=""; 
            for(var i = 0, l = formatData.length; i < l; i++){
                html += tpl({datas: formatData[i]});
            }
            $this.$el.find(".cash-content").html(html).prev().find(".sub-title").html(_.productQuarterReport(datas[0].CashFlow_Date));
        },

        packageProfit: function(data){
            var datas = [{
                    key: "每股收益", value: [], className: ""
                }, {
                    key: "主营收入增长率", value: [], className: ""
                }, {
                    key: "净利润增长率", value: [], className: ""
                }, {
                    key: "营业收入", value: [], className: ""
                }, {
                    key: "营业利润", value: [], className: ""
                }, {
                    key: "净利润", value: [], className: ""
                }];
            for(var i = 0, l = data.length; i < l; i++){
                datas[0].value.push(_.f_numical(data[i].BasicEPS, 2) + "元");
                datas[1].value.push(_.f_numical(data[i].OperatingRevenueGrowRate, 2) + "%");
                datas[2].value.push(_.f_numical(data[i].NPParentCompanyYOY, 2) + "%");
                datas[3].value.push(_.f_numical(data[i].OperatingRevenue, 2) + "元");
                datas[4].value.push(_.f_numical(data[i].OperatingProfit, 2) + "元");
                datas[5].value.push(_.f_numical(data[i].NPParentCompanyOwners, 2) + "元");           
            }
            return datas;
        },

        packageDebt: function(data){
            var datas = [{
                key: "每股净资产", value: [], className: ""
            }, {
                key: "净资产收益率", value: [], className: ""
            }, {
                key: "资产总计", value: [], className: ""
            }, {
                key: "负债总计", value: [], className: ""
            }, {
                key: "股东权益", value: [], className: ""
            }]
            for(var i = 0, l = data.length; i < l; i++){
                datas[0].value.push(_.f_numical(data[i].NetAssetPS, 2) + "元");
                datas[1].value.push(_.f_numical(data[i].ROE, 2) + "%");
                datas[2].value.push(_.f_numical(data[i].TotalAssets, 2)　+ "元");
                datas[3].value.push(_.f_numical(data[i].TotalLiability, 2) + "元");
                datas[4].value.push(_.f_numical(data[i].TotalShareholderEquity, 2) + "元");      
            }
            return datas;
        },
        
        packageCash: function(data){
            var datas = [{
                key: "每股现金流", value: [], className: ""
            }, {
                key: "经营现金流净额", value: [], className: ""
            }, {
                key: "投资现金流净额", value: [], className: ""
            }, {
                key: "筹资现金流净额", value: [], className: ""
            }]
            for(var i = 0, l = data.length; i < l; i++){
                datas[0].value.push(_.f_numical(data[i].CashFlowPS, 2) + "元");
                datas[1].value.push(_.f_numical(data[i].NetOperateCashFlow, 2) + "元");
                datas[2].value.push(_.f_numical(data[i].NetInvestCashFlow, 2) + "元");
                datas[3].value.push(_.f_numical(data[i].NetFinanceCashFlow, 2) + "元");     
            }
            return datas;
        }
    })

    //键值对数据填充

    views.K_VBase = views.baseView.extend({
        isRender: false,
        addBottomColor: false,
        init: function(ops, navIndex){
            var $this = this, flag = true, deferr;
            $(".main-content:nth(" + navIndex + ") > div").hide();
            var $tmp = $(".main-content ." + this.className.split(" ")[0]);
            if(this.isRender) $tmp.remove();
            else if($tmp.length > 0) flag = false;
            if(flag){
                this.$el.appendTo(".main-content:nth(" + navIndex + ")");             
                deferr = this.requestData(ops);
            }  
            this.$el.show();
            if(flag){
                $.when(deferr).done(redrawWebviewHeight);
            }else{
                redrawWebviewHeight();
            }
        }, 
        repurchase: function(data, ops){},
        requestData: function(ops){},
        packageData: function(data){},
        packageTitle: function(){return {data: [{}]}}
    });
    //多产品数据
    views.MoreListK_V = views.K_VBase.extend({
        repurchase: function(data, ops){
            this.$el.html("");
            var datas = data, formatData, tpl =_.template(htmls.company_intro.join("")), html="";            
            for(var i = 0, l = data.length; i < l; i++){
                var $thtml =  $(_.template(htmls.company)(this.packageTitle()));
                formatData = this.packageData(datas[i]);
                html = "";
                for(var j = 0, t = formatData.length; j < t; j++){
                    html += tpl(formatData[j]);
                }
                $thtml.appendTo(this.$el).find(".detail-content").html(html);
            }
            if(this.addBottomColor){
               this.$el.find("div.direct-child:not(':last')").addClass("bottom-color").css("padding-bottom", "1em");
            }
        }
    })

    //单产品数据
    views.SingleListK_V = views.K_VBase.extend({
        repurchase: function(data, ops){
            this.$el.html("");
            var formatData, tpl =_.template(htmls.company_intro.join("")), html="";            
            formatData = this.packageData(data);
            for(var j = 0, t = formatData.length; j < t; j++){
                html += tpl(formatData[j]);
            }
            $(_.template(htmls.company)(this.packageTitle())).appendTo(this.$el).find(".detail-content").html(html);
            if(_.isFunction(this.doOthers)){
                this.doOthers(data, ops);
            }
        }
    })

    //回购
    views.Repurchase = views.MoreListK_V.extend({
        className: "repurchase normal-font",
        addBottomColor: true,
        requestData: function(ops){
            var $this = this, datas = rdata.redatas;
            //deferr = Net.Repurchase(ops, function(data){
            // console.log("回购：", data);
            //var datas = (data && data.Repurchase && data.Repurchase[0]) || [];
            $this.repurchase(datas, ops);                   
            //});
            //return deferr;
        },

        packageData: function(data){
            var datas = [{
                    key: "回购名称: ", value: data.name || "--"
                }, {
                    key: "交易市场: ", value: k_vCodeMarket[data.market] || "--"
                }, {
                    key: "回购代码: ", value: data.code || "--"
                }, {
                    key: "交易指引: ", value: data.intro || "--"
                }, {
                    key: "交易费用: ", value: data.cost || "--"
                }, {
                    key: "相关产品: ", value: data.associate || "--"
                }];
            return datas;
        },

        packageTitle: function(){
            return {data: [{
                mainTitle: "品种介绍"
            }]}
        }
    })

    //基金概况
    views.FundBrief = views.SingleListK_V.extend({
        className: "fundbrief normal-font",
        isRender: true,
        requestData: function(ops){
            var $this = this,
            deferr = Net.Fund(ops, function(data){
                var datas = (data && data.Fund && data.Fund[0] && data.Fund[0][0]) || [];
                $this.repurchase(datas, ops);                   
            });
            return deferr;
        },
        packageTitle: function(){
            return {data: [{
                className: ""
            }, {
                mainTitle: "历史净值", className: "histroyincome-content"
            }, {
                mainTitle: "持股明细", className: "havestocking-content"
            }]}
        },

        packageData: function(data){
            var datas = [{
                    key: "基金名称: ", value: data.SecuAbbr || "--"
                }, {
                    key: "基金类型: ", value: data.CategoryName || "--"
                }, {
                    key: "单位净值: ", value: _.toFixedn(data.UnitNetValue, 0, 3) + "元"
                }, {
                    key: "累计净值: ", value: _.toFixedn(data.AccumlatedUNV, 0, 3) + "元"
                }, {
                    key: "净值日期: ", value: _.f_date(data.EndDate)              
                }, {
                    key: "基金份额: ", value: _.f_numical(data.EndShares) + "股"
                }, {
                    key: "资产净值: ", value: _.f_numical(data.NetAssetsValue) + "元"
                }, {
                    key: "基金经理: ", value: data.Name || "--"
                }, {
                    key: "基金管理人: ", value: data.InvestAdvisor || "--"
                }, {
                    key: "基金托管人: ", value: data.TrusteeName || "--"
                }, {
                    key: "管理费率: ", value: _.toFixedn(data.ManagementFreeProportion) + "%"
                }, {
                    key: "成立日期: ", value: _.f_date(data.EstablishmentDate)
                }];
            return datas;
        },

        packageList1Title: function(data){
            return {data: [{
                    key: "日期", className: "box_flex_1"
                }, {
                    key: "单位净值"
                }, {
                    key: "累计净值"
            }]};
        },
        packageList2Title: function(data){
            return {data: [{
                    key: "证券名称", className: "box_flex_1"
                }, {
                    key: "持仓市值（元）"
                }, {
                    key: "持仓比例（%）"
                }, {
                    key: "截至日期"
            }]};
        },

        packageList1: function(data){
            return {data: [{
                    key: _.f_date(data.EndDate), className: "box_flex_1"
                }, {
                    key: _.toFixedn(data.UnitNetValue, 0, 3)
                }, {
                    key: _.toFixedn(data.UnitTradeThisYear, 0, 3)       
            }]};
        },

        packageList2: function(data){
            return {data: [{
                    key: data.HoldingSecuAbbr || "--", className: "box_flex_1"
                }, {
                    key: _.f_numical(data.MarketValue)
                }, {
                    key: _.f_numical(data.RatioInNV)
                }, {
                    key: _.f_date(data.EndDate)
            }]}
        },

        doOthers: function(data, ops){
            var deferr1 = this.getListOfHistroyList(ops), $this = this,
            deferr2 = this.getListOfHaveStock(ops)
            $.when(deferr1, deferr2).done(function(){
                $this.$el.find("div.direct-child:not(':last')").addClass("bottom-color").css("padding-bottom", "1em");
                redrawWebviewHeight();
            });            
        },

        //获取历史净值列表
        getListOfHistroyList: function(ops){
            var $this = this, 
            deferr = Net.NetValue(ops, function(data){
                var datas = (data && data.NetValue && data.NetValue[0]) || [{}];
                // console.log("历史净值:", datas);               
                $this.writeIntoHistroyList(datas);                   
            });
            return deferr;
        },

        //获取持仓明细列表
        getListOfHaveStock: function(ops){
            var $this = this, 
            deferr = Net.StockPortfolio(ops, function(data){
                var datas = (data && data.StockPortfolio && data.StockPortfolio[0]) || [{}];
                // console.log("持仓明细:", datas);               
                $this.writeIntoHaveStock(datas);                   
            });
            return deferr;
        },

        writeIntoHistroyList: function(data){
            var formatData = this.packageList1Title(), tpl =_.template(htmls.listLine.join("")), html=""; 
            $(".histroyincome-content", this.$el).html("").append(tpl(formatData));
            for(var i = 0, l = data.length; i < l; i++){
                formatData = this.packageList1(data[i]);
                $(".histroyincome-content", this.$el).append(tpl(formatData));
            }
        },

        writeIntoHaveStock: function(data){
            var formatData = this.packageList2Title(), tpl =_.template(htmls.listLine.join(""));
            $(".havestocking-content", this.$el).html("").append(tpl(formatData));
            for(var i = 0, l = data.length; i < l; i++){
                formatData = this.packageList2(data[i]);
                $(".havestocking-content", this.$el).append(tpl(formatData));
            }
        }
    })

    //可转债
    views.ConvBondsBrief = views.SingleListK_V.extend({
        className: "convbondsbrief normal-font",
        isRender: true,      
        requestData: function(ops){
            var $this = this,
            deferr = Net.ConDBInfo(ops, function(data){
                var datas = (data && data.ConBDInfo && data.ConBDInfo[0] && data.ConBDInfo[0][0]) || {};
                // console.log("可转债数据:", datas);               
                $this.repurchase(datas, ops);                   
            });
            return deferr;
        },

        packageData: function(data){
            var datas = [{
                    key: "债券名称: ", value: data.SecuAbbr || "--"
                }, {
                    key: "正股简称: ", value: data.StockAbbr || "--"
                }, {
                    key: "交易市场: ", value: k_vCodeMarket[data.Exchange]
                }, {
                    key: "发行规模: ", value: _.f_numical(data.IssueVol) + "元"
                }, {
                    key: "最新规模: ", value: _.f_numical(data.ToTalBalance) + "元"
                }, {
                    key: "发行价格: ", value: _.f_numical(data.IssuePrice) + "元"
                }, {
                    key: "债券信用级别: ", value: data.CreditRating || "--"
                }, {
                    key: "最新利率: ", value: _.toFixedn(data.InterestRate) + "%"
                }, {
                    key: "还本付息期限和方式: ", value: data.InterestRateExplain || "--"
                }, {
                    key: "利率条款描述: ", value: data.InterestPayDate || "--"
                }, {
                    key: "最新回购折算率: ", value: _.toFixedn(data.Coefficient) + "%"
                }, {
                    key: "上市日期: ", value: _.f_date(data.ListedDate)
                }, {
                    key: "起息日期: ", value: _.f_date(data.InterestStartDate)
                }, {
                    key: "到期日期: ", value: _.f_date(data.MaturityEndDate)
                }, {
                    key: "兑付日期: ", value: _.f_date(data.CashDate)
                }, {
                    key: "债券期限: ", value: _.f_numical(data.BondTerm) + "年"
                }, {
                    key: "摘牌日期: ", value: _.f_date(data.EndDate)
            }];
            return datas;
        },

        packageTitle: function(){
            return {data: [{
                className: ""
            }, {
                mainTitle: "持有人回售条款", className: "saleterms-content"
            }, {
                mainTitle: "发行人提前赎回条款", className: "reterms-content"
            }, {
                mainTitle: "股东情况", className: "stockerdetail-content"
            }, {
                mainTitle: "基金持仓", className: "fundhave-content"
            }]}
        },

        packageList1Title: function(data){
            return {data: [{
                    key: "股东名称", className: "box_flex_1"
                }, {
                    key: "持券金额(万元)"
                }, {
                    key: "所占比例(%)"
                }, {
                    key: "股东性质"
            }]};
        },
        packageList2Title: function(data){
            return {data: [{
                    key: "基金名称", className: "box_flex_1"
                }, {
                    key: "持券量（万张）"
                }, {
                    key: "市值金额（万元）"
                }, {
                    key: "期末净值比"
            }]};
        },

        packageList1: function(data){
            return {data: [{
                    key: data.HolderName || "--", className: "box_flex_1"
                }, {
                    key: _.toFixedn(data.HoldAmount)
                }, {
                    key: _.toFixedn(data.HoldRatio)
                }, {
                    key: data.HolderNature || "--"
            }]};
        },

        packageList2: function(data){
            return {data: [{
                    key: data.SecuAbbr || "--", className: "box_flex_1"
                }, {
                    key: _.toFixedn(data.RationInSV)
                }, {
                    key: _.toFixedn(data.MarketValue)
                }, {
                    key: _.toFixedn(data.RatioInNV)
            }]}
        },

        doOthers: function(data, ops){
            this.addProco(data);
            var deferr1 = this.getListOfStockerInfo(ops), $this = this,
            deferr2 = this.getListOfFundHave(ops)
            $.when(deferr1, deferr2).done(function(){
                $this.$el.find("div.direct-child:not(':last')").addClass("bottom-color").css("padding-bottom", "1em");
                redrawWebviewHeight();
            });            
        },

        //获取基金持仓列表
        getListOfFundHave: function(ops){
            var $this = this, 
            deferr = Net.BondPortfolio(ops, function(data){
                var datas = (data && data.BondPortfolio && data.BondPortfolio[0]) || [{}];
                // console.log("基金持仓:", datas);               
                $this.writeIntoFundHave(datas);                   
            });
            return deferr;
        },

        writeIntoFundHave: function(data){
            var formatData = this.packageList2Title(), tpl =_.template(htmls.listLine.join("")), html=""; 
            $(".fundhave-content", this.$el).html("").append(tpl(formatData));
            for(var i = 0, l = data.length; i < l; i++){
                formatData = this.packageList2(data[i]);
                $(".fundhave-content", this.$el).append(tpl(formatData));
            }
        },

        writeIntoStockerInfo: function(data){
            var formatData = this.packageList1Title(), tpl =_.template(htmls.listLine.join(""));
            $(".stockerdetail-content", this.$el).html("").append(tpl(formatData));
            for(var i = 0, l = data.length; i < l; i++){
                formatData = this.packageList1(data[i]);
                $(".stockerdetail-content", this.$el).append(tpl(formatData));
            }
        },

        //获取股东情况列表
        getListOfStockerInfo: function(ops){
            var $this = this, 
            deferr = Net.ConBDHolder(ops, function(data){
                var datas = (data && data.ConBDHolder && data.ConBDHolder[0]) || [{}];
                // console.log("股东情况:", datas);               
                $this.writeIntoStockerInfo(datas);                   
            });
            return deferr;
        },
        //添加回售和赎回条款
        addProco: function(data){
            $(".saleterms-content", this.$el).html(data.SellBackTerm || "");
            $(".reterms-content", this.$el).html(data.RedeemTerm || "");
        }
    })

    //可转债--转股资料
    views.ConvBondsInfo = views.SingleListK_V.extend({
        className: "convbondsinfo normal-font",
        isRender: true,

        requestData: function(ops){
            var $this = this,
            deferr = Net.ConBDConvert(ops, function(data){
                var datas = (data && data.ConBDConvert && data.ConBDConvert[0] && data.ConBDConvert[0][0]) || [];
                $this.repurchase(datas, ops);                   
            });
            return deferr;
        },

        packageTitle: function(){
            return {data: [{
                className: ""
            }, {
                mainTitle: "转股情况", className: "restockerdetail-content"
            }]}
        },

        packageListTitle: function(data){
            return {data: [{
                    key: "日期"
                }, {
                    key: "本次转股数量(股)"
                }, {
                    key: "本次转股金额(元)"
                }, {
                    key: "转股价(元)"
                }, {
                    key: "累计转股数量(股)", className: "box_flex_1"
                }, {
                    key: "最新规模(元)"
            }]};
        },

        packageList: function(data){
            return {data: [{
                    key: _.f_date(data.EndDate)
                }, {
                    key: _.f_numical(data.VolThisPeriod)
                }, {
                    key: _.f_numical(data.AmountThisPeriod)
                }, {
                    key: _.f_numical(data.CovertPrice)
                }, {
                    key: _.f_numical(data.TotalAmountConverted), className: "box_flex_1"
                }, {
                    key: _.f_numical(data.RemainingAmount)
            }]};
        },


        packageData: function(data){
            var datas = [{
                    key: "最新转股价: ", value: _.f_numical(data.LatestConvPrice) + "元", className: ""
                }, {
                    key: "转股起始日: ", value: _.f_date(data.ConvTermStartDate), className: ""
                }, {
                    key: "转股截止日: ", value: _.f_date(data.ConvTermEndDate), className: ""
                }, {
                    key: "转股价变动情况: ", value: data.AccumlatedUNV || "--", className: ""
                }];
            return datas;
        },
        
        doOthers: function(data, ops){
            var $this = this;
            Net.ConBDRemainAmount(ops, function(data){
                var datas = (data && data.ConBDRemainAmount && data.ConBDRemainAmount[0]) || [];
                // console.log("转股情况", datas)
                $this.writeIntoStockerInfo(datas);       
                $this.$el.find("div.direct-child:not(':last')").addClass("bottom-color").css("padding-bottom", "1em"); 
                redrawWebviewHeight();                  
            });           
        },

        writeIntoStockerInfo: function(data){
            var formatData = this.packageListTitle(), tpl =_.template(htmls.listLine.join(""));
            // console.log(this.packageListTitle());
            $(".restockerdetail-content", this.$el).html("").append(tpl(formatData));
            for(var i = 0, l = data.length; i < l; i++){
                formatData = this.packageList(data[i]);
                $(".restockerdetail-content", this.$el).append(tpl(formatData));
            }
        }
    })

    //债券概况
    views.BondBrief = views.SingleListK_V.extend({
        className: "bondbrief normal-font",
        isRender: true,
        requestData: function(ops){
            var $this = this,
            deferr = Net.BasicInfo(ops, function(data){
                var datas = (data && data.BasicInfo && data.BasicInfo[0] && data.BasicInfo[0][0]) || [];
                $this.repurchase(datas, ops);                   
            });
            return deferr;
        },
        packageData: function(data){
            var datas = [{
                    key: "债券名称: ", value: data.SecuAbbr || "--"
                }, {
                    key: "交易市场: ", value: k_vCodeMarket[data.Exchange] || data.Exchange || "--"
                }, {
                    key: "发行规模: ", value: _.f_numical(data.IssueVol) + "元"
                }, {
                    key: "发行价格: ", value: _.f_numical(data.IssuePrice) + "元"
                }, {
                    key: "债券信用评级: ", value: data.CreditRating || "--"
                }, {
                    key: "最新利率: ", value: _.toFixedn(data.InterestRate) + "%"
                }, {
                    key: "还本付息期限和方式: ", value: data.InterestPayDate || "--"
                }, {
                    key: "利率条款描述: ", value: data.InterestPayDate || "--"
                }, {
                    key: "最新回购折算率: ", value: _.toFixedn(data.Coefficient) + "%"
                }, {
                    key: "上市日期: ", value: _.f_date(data.ListedDate)
                }, {
                    key: "起息日期: ", value: _.f_date(data.InterestStartDate)
                }, {
                    key: "到期日期: ", value: _.f_date(data.MaturityEndDate)
                }, {
                    key: "兑付日期: ", value: _.f_date(data.CashDate)
                }, {
                    key: "债券期限: ", value: _.f_numical(data.BondTerm) + "年"
                }, {
                    key: "摘牌日期: ", value: _.f_date(data.EndDate)
                }];
            return datas;
        }
    })
    var navsView, _stockKind = ""
    //判断股票类型，显示不同的页面。
    Net.StockCategory({Code: code}, function(data){
        var datas = (data && data.StockCategory && data.StockCategory[0] && data.StockCategory[0][0]) || {};
        _stockKind = k_vCodeKind(datas.CategoryCode)
        if(_stockKind == "others"){
            window.ShortTips.install("你输入的代码或者市场有误");
            return;
        }
        config.navs = config.kinds[_stockKind];
        navsView = new views.Navs();
    });

    function redrawWebviewHeight(){
        if(isApp =="android"){
            window.demo.clickOnAndroid($("body").outerHeight(), $("body").css("background-color"));
            return 
        }else if(isApp == "ios"){
            var url = "JSCommunicateOC/height:" + getHeight() + "?time=" + new Date().getTime();
            location.href = url;
            return;
        }   
    }

    function k_vCodeKind(tcode){
        var ecode = (tcode || "").substring(0, 3);
        switch(ecode){
            case "001": 
                return "gp";
            case "002":
                return "jj";
                break;
            case "003":
                if(tcode == "003004")
                    return "kzz";
                else
                    return "zq";
                break;
            case "004":
                return "hg";
                break;
            case "005":
                return "jj";
                break;
            default:
                return "others";
                break; 
        }
    }

    //回购数据： 固定
    rdata = {};
    rdata.default = [{
        name: "{1}天国债回购", 
        market: "SS", 
        code: "{1}", 
        intro: "<p>逆回购交易为投资者融出资金获取利息收益的方式</p><p></p><p>交易方向：“卖出”</p><p>资金门槛：10万（含）整数倍起</p><p>收益率：委托成交价格即为收益率（不包含手续费）</p><p>收益周期：{1}个自然日</p>",
        cost: "成交金额的 {1}( 双向 )",
        associate: "<p>204001    GC001    1天国债回购</p><p>204002    GC002    2天国债回购</p><p>204003    GC003    3天国债回购</p><p>204004    GC004    4天国债回购</p><p>204007    GC007    7天国债回购</p><p>204014    GC014    14天国债回购</p><p>204028    GC028    28天国债回购</p><p>204091    GC091    91天国债回购</p><p>204182    GC182    182天国债回购</p>" 
    }, {
        name: "深{1}天国债回购", 
        market: "SZ", 
        code: "{1}", 
        intro: "<p>逆回购交易为投资者融出资金获取利息收益的方式</p><p></p><p>交易方向：“卖出”</p><p>资金门槛：1000元（含）整数倍起</p><p>收益率：委托成交价格即为收益率（不包含手续费）</p><p>收益周期：1个自然日</p>",
        cost: "<p>成交金额在100万元以下（含）每笔收0.1元，反向交易不再收取</p><p>成交金额在100万元以上每笔收1元，反向交易不再收取</p>",
        associate: "<p>131810    R-001    1天国债回购</p><p>131811    R-002    2天国债回购</p><p>131800    R-003    3天国债回购</p><p>131809    R-004    4天国债回购</p><p>131801    R-007    7天国债回购</p><p>131802    R-014    14天国债回购</p><p>131803    R-028    28天国债回购</p><p>131805    R-091    91天国债回购</p><p>131806    R-182    182天国债回购</p>" 
    }];
    rdata.redatas = [];
    (function(){
        var codes = ["131810", "131811", "131800", "131809", "131801", "131802", "131803", "131805", "131806"], 
            scodes = ["204001", "204002", "204003", "204004", "204007", "204014", "204028", "204091", "204182"], 
            days = ["1", "2", "3", "4", "7", "14", "28", "91", "182"], 
            profits = ["0.00005%", "0.00010%", "0.00015%", "0.00020%","0.00025%", "0.00050%", "0.00100%", "0.00150%", "0.00150%"], 
            tmp, i, t;

        for(i = 0; i < 9; i++){
            t = i + 9;
            tmp = _.clone(rdata.default[0]);
            // console.log(days[i]);
            tmp.name = tmp.name.replace("{1}", days[i]);
            tmp.code = tmp.code.replace("{1}", scodes[i]);
            tmp.intro = tmp.intro.replace("{1}", days[i]);
            tmp.cost = tmp.cost.replace("{1}", profits[i]);
            rdata.redatas[i] = tmp;
            tmp = _.clone(rdata.default[1]);
            tmp.name = tmp.name.replace("{1}", days[i]);
            tmp.code = tmp.code.replace("{1}", codes[i]);
            tmp.intro = tmp.intro.replace("{1}", days[i]);
            rdata.redatas[t] = tmp;
        }
    })();

})();               

function getHeight(){
    return $("body").outerHeight();
}
