;(function(){
	var views = window.views = window.views || {};
	views.baseView = Backbone.View.extend({
	    initialize: function(ops){
	    	this.initEvents();
            this.delegateEvents(this.events);
	        this.init(ops);
	    },
	    initEvents: function(){
	    	var $this = this, tap = this.tap;
            $this.events = {};
	    },
	    init: function(){},
	    //tap: "click",
	    tap: ("ontouchstart" in window && isApp != 'ios' && navigator.userAgent.indexOf("mac") == -1) ? "touchend" : "click",
	    touchstart: "ontouchstart" in window ? "touchstart" : "mousedown",
	    touchmove: "ontouchmove" in window ? "touchmove" : "mouseup",
	    listenToEvents: function($target, ev, callback){  
	        $target.off(ev).on(ev, $.proxy(function(e){
	            if(ev == "touchend" || ev == "click"){
	                var $this = this;
	                function doEvent(){                   
	                    if(!$this.IsMove){
	                        callback.call($this, e);
	                    }                         
	                }
	                doEvent(); 
	            }else{
	                callback.call(this, e);
	            }
	        }, this));
	    },
	    touchStart:function(e){
	        var $this=this;
	        $this.IsMove = false;
	        if($this.touchmove=='touchmove'){
	            $this.x = e.originalEvent.targetTouches[0].clientX;
	            $this.y = e.originalEvent.targetTouches[0].clientY;
	        }else{
	            $this.x = e.pageX;
	            $this.y = e.pageY;
	        }
	    },
	    packageJSON: function(data, datas, flag){
	    	var index = -1, curentIsTitle = false;
			var rdatas = [], tmpdatas;
			for(var i = 0; i < datas.length; i++){				
				if(datas[i][2] && datas[i][2].indexOf(flag) == -1){
					continue;
				}
				if(!_.isArray(datas[i])){
					index++;
					curentIsTitle = true;
					continue;
				}
				if(curentIsTitle){
					rdatas.push({
						title: {
							key: datas[i][0], value: [], className: datas[i][3] || ""
						}, 
						value: []
					})
					tmpdatas = rdatas[index].title;
					curentIsTitle = false;
				}else{
					rdatas[index].value.push({
						key: datas[i][0] , value: [], className: datas[i][3] || ""
					})
					tmpdatas = rdatas[index].value[rdatas[index].value.length-1]
				}
				for(var j = 0, l = data.length; j < l; j++){
					if(!datas[i][1]){
						tmpdatas.value.push("&nbsp;");
					}else{
						var num;
						((num = _.f_numical(data[j][datas[i][1]], null, null, "--")) == "--") || (num = num + "元");
						tmpdatas.value.push(num);
					}
				}
			}
			return rdatas;
	    },
	    showResult: function(datas, flag){
	    	var tables = ["packageProfitTable", "packageDebtTable", "packageCushTable"], $this = this;
	    	if(!datas.length){
                window.ShortTips.install("查询数据为空");
                return false;
            }
            $this.datas = datas;
			var formatData = $this.formatData = this[tables[flag]](datas, datas[0].CompanyType), tplTilte = _.template(htmls.listArti.join("")), tpl = _.template(htmls.listArtiContent.join("")), html="", tmp="",
				dlength = $this.datalength = formatData[0].value[0].value.length, i, l = formatData.length, j, k;
			for(i = 0; i < l; i++){
				html += tplTilte({datas: formatData[i].title});
				tmp = formatData[i].value;
				for(j = 0, k = tmp.length; j < k; j++){
					html += tpl({datas: tmp[j]});
				}
			}
			this.$el.find(".list-detail").append(html);
			$(".header .sessionreport").html(_.productQuarterReport(datas[this.currentPage - 1].EndDate));
			$(".header .main-title").html(datas[this.currentPage - 1].SecuName);  
			var divwidth = this.$el.find(".value").width(), tap = $this.tap;
			this.$el.find(".inner").css("margin-left", divwidth * (1 - dlength)).animate({"margin-left": 0}, 1000);

			$(".icon-left-wrap").off(tap).on(tap, $.proxy($this.moveLeft, $this));
			$(".icon-right-wrap").off(tap).on(tap, $.proxy($this.moveRight, $this));
			$this.listenToEvents($this.$el, $this.touchstart, $this.touchStart);
	        $this.listenToEvents($this.$el, $this.touchmove, function(e){
	            if(!$this.IsMove){
	                var pageX= null;
	                if($this.touchmove=='touchmove'){
	                    pageX= e.originalEvent.targetTouches[0].clientX;           
	                }else{
	                    pageX= e.pageX;
	                }
	                
	                if (pageX - $this.x > 50 ) {
	                    $this.moveLeft();
	                }else if( pageX - $this.x < -50){
	                    //向右滑动
	                    $this.moveRight();
	                }else{
	                    $this.IsMove=false;
	                }        
	            }
	            $this.IsMove = true;
	        },  1000);             
	    },

	    moveLeft: function(){
	    	//向左滑动
	    	var $this = this, formatData = $this.formatData, dlength = $this.datalength = formatData[0].value[0].value.length, 
	    		divwidth = this.$el.find(".list-detail .value").width(), datas = $this.datas;
            if($this.currentPage > 1){
                $this.currentPage--;                        
            }else{
            	$this.currentPage = dlength;
            }  
            var marginLeft = (1 - $this.currentPage) * divwidth;  
            $this.$el.find(".inner").animate({"margin-left": marginLeft}, 300);
            $(".header .sessionreport").html(_.productQuarterReport(datas[$this.currentPage - 1].EndDate));                                              
	    },

	    moveRight: function(){
	    	var $this = this, formatData = $this.formatData, dlength = $this.datalength = formatData[0].value[0].value.length, 
	    		divwidth = this.$el.find(".list-detail .value").width(), datas = $this.datas;
	    	if($this.currentPage < dlength){
                $this.currentPage++;	                       
            }else{
            	$this.currentPage = 1
            }
             var marginLeft = (1 - $this.currentPage) * divwidth;  
                $this.$el.find(".inner").animate({"margin-left": marginLeft}, 300); 
                $(".header .sessionreport").html(_.productQuarterReport(datas[$this.currentPage - 1].EndDate));                      
	    }
	})

	//主体
    views.MainView = Backbone.View.extend({
        el: ".main-content",
        initialize: function () {
            var _this = this;
            this.setELheight();
            $(window).resize(function () {
                _this.setELheight();       
                _this.refresh();
            });
            this.initBaseScroll();
            this.$mainContentScroll = $(".main-content-scroll");
        },

        setELheight: function(){
            this.$el.height($(window).height() - $(".header").height() - 10);
        },

        scrollToTop: function(){
           this.myScroll.scrollTo(0, 0);
        },

        initBaseScroll: function () { //初始化iscroll
            this.myScroll = new iScroll("main_content", {
                scrollX: true,
                scrollY: false,
                bounce: false,
                hideScrollbar: true,
                vScrollbar: false,
                onBeforeScrollStart: function (e) { 
                    if($(e.target).is("select") || $(e.target).is("input") || $(e.target).is("textarea")){
                        return;
                    }
                    e.preventDefault();
                },
                onBeforeScrollMove: function(e){
                    if(navigator.userAgent.toLowerCase().indexOf("mac") != -1){                       
                        $(document.activeElement).is("input") && $(document.activeElement).blur();
                    }
                }
            });
        },

        refresh: function () { //刷新iscroll
            this.setELheight();
            var mainHeight = this.$mainContentScroll.height(),
                aHeight = this.$el.height();

            this.myScroll.refresh();
        },

        installLoading: function () {
            this.$(".loading").show();
        },
        
        uninstallLoading: function () {
            this.$(".loading").hide();
        }
    });

	views.profitContent = views.baseView.extend({
		className: "profit",
		currentPage: 1,
		init: function(ops){
			this.$el.html(htmls.finance_content.join("")).appendTo(".main-content-scroll");
			$(".header").html(htmls.finance_title.join(""));
			this.profitTable(ops);	
			mainView.refresh();
		},
		profitTable: function(ops){
			var $this = this;
			Net.InComeStatement(ops, function(data){
				var datas = (data && data.IncomeStatement && data.IncomeStatement[0]) || [];
				$this.showResult(datas, 0);	
				mainView.refresh();
			})		
		},

		packageProfitTable: function(data, flag){
			var datas = ["", ["营业总收入", "TotalOperatingRevenue", "1"], ["营业收入", "OperatingRevenue"], ["手续费及佣金净收入", "NetCommissionIncome", "2,4,5"], ["手续费及佣金收入", "CommissionIncome", "2,5"], ["手续费及佣金支出", "CommissionExpense", "2,5"], ["代理买卖证券业务净收入", "NetProxySecuIncome", "4"], ["证券承销业务净收入", "NetSubIssueSecuIncome", "4"], ["受托客户资产管理业务净收入", "NetTrustIncome", "4"], ["净利息收入", "NetInterestIncome", "2,4,5"], ["利息收入", "InterestIncome", "2,5"], ["利息支出", "InterestExpense", "2,5"], ["已赚保费", "PremiumsEarned", "3"], ["保险业务收入", "PremiumsIncome", "3"], ["其中:分保费收入", "ReinsuranceIncome", "3"], ["减:分出保费", "Reinsurance", "3"], ["提取未到期责任准备金", "UnearnedPremiumReserve", "3"], ["投资净收益", "InvestIncome", "2,3,4,5"], ["其中：对联营公司的投资收益", "InvestIncomeAssociates", "2,3,4,5"], ["公允价值变动收益", "FairValueChangeIncome", "2,3,4,5","intent_3"], ["汇兑收益", "ExchangeIncome", "2,3,4,5","intent_3"], ["其他经营净收益", "OtherNetRevenue", "2,5"], ["其它营业收入", "OtherOperatingRevenue"], 
						 "", ["营业总成本", "TotalOperatingCost", "1"], ["营业成本", "OperatingCost", "1"], ["营业支出", "OperatingPayout", "2,3,4,5"], ["退保金 ", "RefundedPremiums", "3"], ["赔付支出 ", "CompensationExpense", "3"], ["减:摊回赔付支出 ", "AmortizationExpense", "3", , "intent_2"], ["提取保险责任准备金 ", "PremiumReserve", "3"], ["减:摊回保险责任准备金 ", "AmortizationPremiumReserve", "3", "intent_2"], ["保单红利支出 ", "PolicyDividendPayout", "3"], ["分保费用 ", "ReinsuranceCost", "3"], ["保险手续费及佣金支出 ", "InsuranceCommissionExpense", "3"], ["营业税金及附加", "OperatingTaxSurcharges"], ["销售费用", "OperatingExpense", "1"], ["管理费用", "AdministrationExpense", "1"], ["财务费用", "FinancialExpense", "1"], ["业务及管理费用", "OperatingAndAdminExpense", "2,3,4,5"], ["减:摊回分保费用", "AmortizationReinsuranceCost", "3", , "intent_2"], ["其它营业成本", "OtherOperatingCost"], ["资产减值损失", "AssetImpairmentLoss"],
						 "", ["其他经营收益", "", "", ""], ["公允价值变动收益", "FairValueChangeIncome", "1"], ["投资净收益", "InvestIncome", "1"], ["其中：对联营公司的投资收益", "InvestIncomeAssociates", "1"], ["汇兑收益", "ExchangeIncome", "1", "intent_3"], ["营业利润差额特殊科目", "OtherItemsEffectingOP"], ["营业利润差额调整科目", "AdjustedItemsEffectingOP"],
						 "", ["营业利润", "OperatingProfit"], ["加：营业外收入", "NonoperatingIncome", "intent_2"], ["减：营业外支出", "NonoperatingExpense", "intent_2"], ["其中:非流动资产处置净损失", "NonCurrentAssetssDealLoss"], ["利润总额差额特殊科目", "OtherItemsEffectingTP"], ["利润总额差额调整科目", "AdjustedItemsEffectingTP"], 
						 "", ["利润总额", "TotalProfit"], ["减：所得税", "IncomeTaxCost"], ["加:未确认的投资损失", "UncertainedInvestmentLosses"], ["净利润差额特殊科目", "OtherItemsEffectingNP"], ["净利润差额调整科目", "AdjustedItemsEffectingNP"],
						 "", ["净利润", "netProfit"], ["归属于母公司所有者的净利润", "NPParentCompanyOwners"], ["减：少数股东损益", "MinorityProfit"], ["加：其他综合收益", "OtherCompositeIncome"],
						 "", ["综合收益总额", "TotalCompositeIncome"], ["减：归属于少数股东的综合收益总额", "CIMinorityOwners"], ["归属于母公司所有者的综合收益总额", "CIParentCompanyOwners", "", "intent_2"],
						 "", ["每股收益", ""], ["基本每股收益", "BasicEPS"], ["稀释每股收益", "DilutedEPS"]
						 ];
			return this.packageJSON(data, datas, flag);
		}
	})

	views.debtContent = views.baseView.extend({
		className: "debt",
		currentPage: 1,
		init: function(ops){
			this.$el.html(htmls.finance_content.join("")).appendTo(".main-content-scroll");
			$(".header").html(htmls.finance_title.join(""));
			this.debtTable(ops);	
			mainView.refresh();	
		},
		debtTable: function(ops){
			var $this = this;
			Net.BalanceSheet(ops, function(data){
				var datas = (data && data.BalanceSheet && data.BalanceSheet[0]) || [];
				$this.showResult(datas, 1);	
				mainView.refresh();				
			});		
		},

		packageDebtTable: function(data, flag){
			var datas = ["", 
						["资产", ""],
						["货币资金","OperatingRevenue","1,3,4"], 
						["现金及存入中央银行款项", "CashEquivalents", "2,5"],
					    ["其中:客户资金存款", "ClientDeposit","4"],
						["结算准备金", "SettlementProvi","4"],
						["其中:客户备付金", "ClientProvi","4"],
						["存放同业款项", "DepositInInterbank","2,5"],
						["贵金属", "RMetal","2"],
						["拆出资金", "LendCapital","2,3,4,5"],
						["交易性金融资产", "TradingAssets"],
						["衍生金融资产", "DerivativeAssets","2,3,4,5"],
						["买入返售金融资产", "BoughtSellBackAssets"],
						["应收保费", "InsuranceReceivables","3"],
						["应收代位追偿款", "ReceivableSubrogationFee","3"],
						["应收分保账款", "ReinsuranceReceivables","3"],
						["应收分保未到期责任准备金", "ReceivableUnearnedR","3"],
						["应收分保未决赔款准备金", "ReceivableClaimsR","3"],
						["应收分保寿险责任准备金", "ReceivableLifeR","3"],
						["应收分保长期健康险责任准备", "ReceivableLTHealthR","3"],
						["保户质押贷款", "InsurerImpawnLoan","3"],
						["定期存款", "FixedDeposit","3,4"],
						["应收票据", "BillReceivable"],
						["应收账款", "AccountReceivable"],
						["预付款项", "AdvancePayment","1"],
						["应收利息", "InterestReceivable"],
						["应收股利", "DividendReceivable"],
						["其他应收款", "OtherReceivable"],
						["存货", "Inventories","1"],
						["其中:消耗性生物资产", "BearerBiologicalAssets","1"],
						["一年内到期的非流动资产", "NonCurrentAssetIn1Year","1"],
						["待摊费用", "DeferredExpense"],
						["其他流动资产", "OtherCurrentAssets","1"],
						["其他金融流动资产", "","1"],
						["结算准备金", "SettlementProvi","1"],
						["拆出资金", "LendCapital","1"],
						["衍生金融资产", "DerivativeAssets","1"],
						["存放同业款项", "DepositInInterbank","1"],
						["流动资产特殊项目", "CAExceptionalItems","1"],
						["流动资产调整项目", "CAAdjustmentItems","1"],
						["流动资产合计", "TotalCurrentAssets","1"],
						["非流动资产", "","1"],
						["存出保证金", "RefundableDeposit","2,3,4,5"],
						["发放贷款和垫款", "LoanAndAdvance"],
						["代理业务资产", "","2,4,5"],
						["可供出售金融资产", "HoldForSaleAssets"],
						["持有至到期投资", "HoldToMaturityInvestments"],
						["长期应收款", "LongtermReceivalbeAccount","1,2,3,5"],
						["长期股权投资", "LongtermEquityInvest"],
						["投资性房地产", "InvestmentProperty"],
						["存出资本保证金", "RefundableCapitalDeposit","3,4"],
						["应收款项类投资", "LoanAndAccountReceivables","2,3,5"],
						["固定资产", "FixedAssets"],
						["在建工程", "ConstruInProcess","1"],
						["工程物资", "ConstructionMaterials","1"],
						["固定资产清理", "FixedAssetsLiquidation","1"],
						["生产性生物资产", "BiologicalAssets","1"],
						["油气资产", "DevelopmentExpenditure","1"],
						["开发支出", "OilGasAssets","1"],
						["无形资产", "IntangibleAssets"],
						["其中:交易席位费", "SeatCosts","4"],
						["商誉", "GoodWill"],
						["独立账户资产", "IndependenceAccountAssets","3"],
						["长期待摊费用", "LongDeferredExpense"],
						["递延所得税资产", "DeferredTaxAssets"],
						["其它资产", "OtherAssets","2,3,4,5"],
						["其他非流动资产", "OtherNonCurrentAssets","1"],
						["非流动资产特殊项目", "NCAExceptionalItems","1"],
						["非流动资产调整项目", "NCAAdjustmentItems","1"],
						["非流动资产合计", "TotalNonCurrentAssets","1"],
						["资产特殊项目", "AExceptionalItems"],
						["资产调整项目", "AAdjustmentItems"],
						["资产总计", "TotalAssets"],
					"",
						["负债", ""],
						["短期借款", "ShortTermLoan","1,3,4"],
						["其中:质押借款", "ImpawnedLoan","4"],
						["向中央银行借款", "BorrowingFromCentralBank","2,5"],
						["同业及其他金融机构存放款项", "DepositOfInterbank","2,5"],
						["拆入资金", "BorrowingCapital","2,3,4,5"],
						["交易性金融负债", "TradingLiability"],
						["衍生金融负债", "DerivativeLiability","2,3,4,5"],
						["卖出回购金融资产款", "SoldBuybackSecuProceeds","2,3,4,5"],
						["代理买卖证券款", "ProxySecuProceeds","4"],
						["代理承销证券款", "SubIssueSecuProceeds","4"],
						["吸收存款", "Deposit","2,5"],
						["应付票据", "NotesPayable","1"],
						["应付账款", "AccountsPayable"],
						["预收款项", "AdvanceReceipts"],
						["预收保费", "AdvanceInsurance","3"],
						["应付手续费及佣金", "CommissionPayable","1,3,4,5"],
						["应付分保账款", "ReinsurancePayables","3"],
						["应付职工薪酬", "SalariesPayable"],
						["应交税费", "TaxsPayable"],
						["应付利息", "InterestPayable"],
						["应付股利", "DividendPayable"],
						["代理业务负债", "","2,5"],
						["应付赔付款", "CompensationPayable","3"],
						["应付保单红利", "PolicyDividendPayable","3"],
						["存入保证金", "DepositsReceived","2,3,4,5"],
						["保户储金及投资款", "InsurerDepositInvestment","3"],
						["未到期责任准备金", "UnearnedPremiumReserve","3"],
						["未决赔款准备金", "OutstandingClaimReserve","3"],
						["寿险责任准备金", "LifeInsuranceReserve","3"],
						["长期健康险责任准备金", "LTHealthInsuranceLR","3"],
						["其他应付款", "OtherPayable"],
						["一年内到期的非流动负债", "NonCurrentLiabilityIn1Yea","1"],
						["预提费用", "AccruedExpense","1"],
						["递延收益", "DeferredProceeds","1,2，4,5"],
						["应付短期债券", "STBondsPayable","1,2,5"],
						["其他流动负债", "OtherCurrentLiability","1"],
						["预提费用", "","1"],
						["同业及其他金融机构存放款项", "DepositOfInterbank","1"],
						["拆入资金", "BorrowingCapital ","1"],
						["卖出回购金融资产款  ", "SoldBuybackSecuProceeds","1"],
						["衍生金融负债", "DerivativeLiability","1"],
						["应付分保账款", "ReinsurancePayables","1"],
						["流动负债特殊项目", "CLExceptionalItems","1"],
						["流动负债调整项目", "CLAdjustmentItems","1"],
						["流动负债合计", "TotalCurrentLiability","1"],
						["非流动负债", "","1"],
						["长期借款 ", "LongtermLoan","1,3,4"],
						["应付债券", "BondsPayable"],
						["长期应付款", "LongtermAccountPayable","1,2,5"],
						["专项应付款", "SpecificAccountPayable","1"],
						["预计负债", "Estimatelibility"],
						["递延所得税负债", "DeferredTaxLiability"],
						["独立账户负债 ", "IndependenceLiability","3"],
						["其它负债", "OtherLiability","2,3,4,5"],
						["其他非流动负债", "OtherNonCurrentLiability","1"],
						["非流动负债特殊项目", "NCLExceptionalItems","1"],
						["非流动负债调整项目", "NCLAdjustmentItems","1"],
						["非流动负债合计", "TotalNonCurrentLiability","1"],
						["负债特殊项目", "LExceptionalItems"],
						["负债调整项目", "LAdjustmentItems"],
						["负债合计", "TotalLiability"],
					"",
						["所有者权益",""],
						["股本","PaidInCapital"],
						["资本公积", "CapitalReserveFund"],
						["库存股", "TreasuryStock"],
						["专项储备", "SpecificReserves","1"],
						["盈余公积", "SurplusReserveFund"],
						["一般风险准备", "OrdinaryRiskReserveFund"],
						["未分配利润", "RetainedProfit"],
						["外币报表折算差额", "ForeignCurrencyReportConvDiff"],
						["未确认投资损失", "UncertainedInvestmentLoss"],
						["其他储备(公允价值变动储备)", "OtherReserves","1"],
						["股东权益特殊项目", "SEExceptionalItems"],
						["股东权益调整项目", "SEAdjustmentItems"],
					"",
						["归属于母公司股东权益合计", "SEWithoutMI"],
						["少数股东权益", "MinorityInterests"],
					"",
						["股东权益合计", "TotalShareholderEquity"],
						["负债和权益特殊项目", "LEExceptionalItems"],
						["负债和权益特殊项目","LEAdjustmentItems"],
						["负债及股东权益总计", "TotalLiabilityAndEquity"],
						];
			return this.packageJSON(data, datas, flag);
		}
	})

	views.cushContent = views.baseView.extend({
		className: "cush",
		currentPage: 1,
		init: function(ops){
			this.$el.html(htmls.finance_content.join("")).appendTo(".main-content-scroll");
			$(".header").html(htmls.finance_title.join(""));
			this.cushTable(ops);
			mainView.refresh();		
		},
		cushTable: function(ops){
			var $this = this;
			Net.CashFlowStatement(ops, function(data){
				var datas = (data && data.CashFlowStatement && data.CashFlowStatement[0]) || [];
				$this.showResult(datas, 2);	
				mainView.refresh();								
			})
		},

		packageCushTable: function(data, flag){
			var datas = ["", 
						["一：经营活动产生的现金流量", ""],
							["销售商品，提供劳务收到的现金" ,"GoodsSaleServiceRenderCash","1,5"], 
							["收到的税费返还", "TaxLevyRefund", "1,5"],
						    ["客户存款和同业存放款项净增加额","NetDepositIncrease","2"],
							["向中央银行借款净增加额","NetBorrowingFromCentralBank","2"],
							["处置交易性金融资产净增加额", "NetDealTradingAssets","4"], 
							["处置可供出售金融资产净增加额", "","4"], 
							["收取利息、手续费及佣金的现金" ,"InterestAndCommissionCashIn","2,4"], 
							["向其他金融机构拆入资金净增加额","NetBorrowingFromFinanceCo","2,4"], 
							["回购业务资金净增加额", "NetBuyBack","4"], 
							["收回已核销贷款", "DrawBackLoansCanceled","2,4"], 
							["收到原保险合同保费取得的现金", "NetOriginalInsuranceCash","3"],
							["收到再保业务现金净额", "NetReinsuranceCash","3"],
							["收到其它与经营活动有关的现金","OtherCashInRelatedOperate"],
							["客户存款和同业存放款项净增加额", "NetDepositIncrease","1,5"],
							["向其他金融机构拆入资金净增加额", "NetBorrowingFromFinanceCo","1,5"],
							["收取利息、手续费及佣金的现金", "InterestAndCommissionCashIn","1,5"],
							["处置交易性金融资产净增加额" ,"NetDealTradingAssets","1,5"],
							["回购业务资金净增加额","NetBuyBack","1,5"],
							["经营活动现金流入(特殊项目)","SpecialItemsOCIF"],
							["经营活动现金流入(调整项目)","AdjustmentItemsOCIF"],
							["经营活动现金流入小计", "SubtotalOperateCashInflow"],
							["购买商品，接受劳务支付的现金","GoodsServicesCashPaid","1,5" ],
							["客户贷款及垫款净增加额","NetLoanAndAdvanceIncrease","2"],
							["存放中央银行和同业款项净增加额" ,"NetDepositInCBAndIB","2"],
							["拆出资金净增加额","NetLendCapital","2,4" ],
							["支付原保险合同赔付款项的现金" ,"OriginalCompensationPaid","3"],
							["支付保单红利的现金", "PolicyDividendCashPaid","3"],
							["支付再保业务现金净额","NetCashForReinsurance","3" ],
							["支付给职工以及为职工支付的现金 ","StaffBehalfPaid"],
							["支付的各项税费","AllTaxesPaid "],
							["支付利息、手续费及佣金的现金","CommissionCashPaid","2,3,4" ],
							["支付其它与经营活动有关的现金","OtherOperateCashPaid"],
							["客户贷款及垫款净增加额", "NetLoanAndAdvanceIncrease", "1,5"],
							["支付利息、手续费及佣金的现金", "CommissionCashPaid", "1,5" ],
							["存放中央银行和同业款项净增加额","NetDepositInCBAndIB"],
							["经营活动现金流出（特殊项目）","SpecialItemsOCOF"],
							["经营活动现金流出（调整项目）","AdjustmentItemsOCOF"],
							["经营活动现金流出小计","SubtotalOperateCashOutflow"],
							["经营活动现金流量净额调整项目", "AdjustmentItemsNOCF"],
							["经营活动产生的现金流量净额" ,"NetOperateCashFlow"],
						"",
						["二：投资活动产生的现金流量", ""],
							["收回投资收到的现金","InvestWithdrawalCash"],
							["取得投资收益收到的现金" ,"Investproceeds"],
							["处置固定资产、无形资产及其它资产而收到的","FixIntanOtherAssetDispoCash"],
							["处置子公司及其它营业单位所收到的现金净额", "NetCashDealSubCompany"],
							["收到其它与投资活动有关的现金" ,"OtherCashFromInvestAct"],
							["投资活动现金流入特殊项目","SpecialItemsICIF"],
							["投资活动现金流入调整项目", "AdjustmentItemsICIF"],
							["投资活动现金流入小计" ,"SubtotalInvestCashInflow"],
							["购建固定资产、无形资产和其它长期资产支付" ,"FixIntanOtherAssetAcquiCash"],
							["投资支付的现金","InvestCashPaid"],
							["取得子公司及其它营业单位支付的现金净额","NetCashFromSubCompany"],
							["质押贷款净增加额","ImpawnedLoanNetIncrease","1,2,3" ],
							["支付的其它与投资活动有关的现金" ,"OtherCashToInvestAct"],
							["投资活动现金流出特殊项目","SpecialItemsICOF"],
							["投资活动现金流出调整项目","AdjustmentItemsICOF"],
							["投资活动现金流出小计" ,"SubtotalInvestCashOutflow"],
							["投资活动现金流量净额调整项目" ,"AdjustmentItemsNICF"],
							["投资活动产生的现金流量净额", "NetInvestCashFlow"],
						"",
						["三：筹资活动产生的现金流量", ""],
							["吸收投资所收到的现金","CashFromInvest"],
							["其中:子公司吸收少数股东投资收到的现金","CashFromMinoSInvestSub"],
							["取得借款收到的现金" ,"CashFromBorrowing"],
							["发行债券收到的现金" ,"CashFromBondsIssue"],
							["收到其它与筹资活动有关的现金" ,"OtherFinanceActCash"],
							["筹资活动现金流入特殊项目","SpecialItemsFCIF "],
							["筹资活动现金流入调整项目" ,"AdjustmentItemsFCIF"],
							["筹资活动现金流入小计" ,"SubtotalFinanceCashInflow"],
							["偿还债务所支付的现金","BorrowingRepayment"],
							["分配股利，利润或偿付利息支付的现金" ,"DividendInterestPayment"],
							["其中:子公司支付给少数股东的股利、利润或偿付的利", "ProceedsFromSubToMinoS"],
							["支付其它与筹资活动有关的现金" ,"OtherFinanceActPayment"],
							["筹资活动现金流出特殊项目","SpecialItemsFCOF"],
							["筹资活动现金流出调整项目","AdjustmentItemsFCOF"],
							["筹资活动现金流出小计","SubtotalFinanceCashOutflow"],
							["筹资活动流量现金净额调整项目" ,"AdjustmentItemsNFCF"],
							["筹资活动产生的现金流量净额","NetFinanceCashFlow"],
						"",
						["四：汇率变动对现金及现金等价物的影", "ExchanRateChangeEffect"],
						"",
						["五：现金及现金等价物净增加额", "CashEquivalentIncrease"],
							["期初现金及现金等价物余额","BeginPeriodCash"],
							["期末现金及现金等价物余额","EndPeriodCashEquivalent"],
						"",
						["补充资料", ""],
							["1.将净利润调节为经营活动的现金流量", ""],
							["净利润","NetProfit"],
							["加：少数股东损益","MinorityProfit"],
							["资产减值准备" ,"AssetsDepreciationReserves"],
							["固定资产折旧","FixedAssetDepreciation"],
							["无形资产摊销", "IntangibleAssetAmortization"],
							["长期待摊费用摊销", "DeferredExpenseAmort"],
							["待摊费用减少(减:增加)" ,"DeferredExpenseDecreased"],
							["预提费用增加(减:减少)" ,"AccruedExpenseAdded"],
							["处置固定资产、无形资产和其他长期资产的损失","FixIntanOtherAssetDispoLoss"],
							["固定资产报废损失" ,"FixedAssetScrapLoss"],
							["公允价值变动损失", "LossFromFairValueChanges"],
							["财务费用","FinanciaExpense"],
							["投资损失（减：收益）" ,"InvestLoss"],
							["递延所得税资产的减少" ,"DeferedTaxAssetDecrease"],
							["递延所得税负债的增加" ,"DeferedTaxLiabilityIncrease"],
							["存货的减少" ,"InventoryDecrease"],
							["经营性应收项目的增加" ,"OperateReceivableDecrease"],
							["经营性应付项目的增加" ,"OperatePayableIncrease"],
							["其它", "Others"],
							["经营活动现金流量净额" ,"NetOperateCashFlowNotes"],
							["2.不涉及现金流量的投资", ""],
							["债务转为资本","DebtToCaptical"],
							["一年内到期的可转换公司债券" ,"CBsExpiringWithin1Y"],
							["融资租入固定资产","FixedAssetsFinanceLeases"],
							["3.现金及现金等价物净增加/减少额", ""],
							["现金的期末余额","CashAtEndOfYear"],
							["减：现金的期初余额" ,"CashAtBeginningOfYear"],
							["现金等价物的期末余额" ,"NetIncrInCashAndEquivalents"],
							["减：现金等价物的期初余额","CashEquivalentsAtBeginning"],
							["现金及现金等价物净增加额","NetIncrInCashAndEquivalents"],
							];
			return this.packageJSON(data, datas, flag);
		}
	})

	var mainView = new views.MainView();

})();
(function(){
    var type = paramObj.type, TextArray = ["", "利润表", "资产负债表", "现金流量表"], viewArray = ["", "profitContent", "debtContent", "cushContent"];
    if(type < 1 && type > 3) type = 1;
    new views[viewArray[type]]({Code: code});
    window.onunload = function() {
        Net.Log(TextArray[type]);
    };  
})();
