;(function (){
    var views = window.views = window.views || {};

    views.baseView = Backbone.View.extend({
        initialize: function(ops, stockName){
            var type = this.type = paramObj.type;
            $(".loading").hide();
            $(".main .list-main-title").html(config.navs[type].name);
            $(".main .list-sub-title").html("( " + code + ":" + stockName + " )");
            this.init(ops);
            if(this.touchmove == "touchmove"){
                this.listenToEvents($(window), "touchstart", function(){
                    this.moving = false;
                });
                this.listenToEvents($(window), "touchmove", function(){
                    this.moving = true;
                });
            }
        },
        touchmove: "ontouchmove" in window ? "touchmove" : "mouseup",
        init: function(){},
        tap: ("ontouchstart" in window && isApp != 'ios' && navigator.userAgent.indexOf("mac") == -1) ? "touchend" : "click",
        listenToEvents: function($target, ev, callback){  
            $target.off(ev).on(ev, $.proxy(function(e){
                if(ev == "touchend" || ev == "click"){
                    var $this = this;                   
                    function doEvent(){                  
                        if(!$this.moving){
                            callback.call($this, e);
                        }                         
                    }
                    doEvent(); 
                }else{
                    callback.call(this, e);
                }
            }, this));
        }
    })
    //列表
    views.List = views.baseView.extend({
        template: _.template(htmls.list.join("")),
        offset: 0,
        title: "",
        init: function(ops){
            $(".main-content > div").hide();  
            this.insertEL();
            this.$el.parent().show();
            if(!ops){return;}
            this.ops = ops;
            this.ops.Size = 999999;
            this.getNews(ops, this.offset);
        },
        insertEL: function(){},
        getNews: function(ops){},
        getDetail: function(e){
            var $target = $(e.target);
            if(!$target.is("li")) $target = $target.parents("li");
            var id = $target.attr("data-cid"), comefrom = $target.attr("data-come"),t = {}; 
            t = JSON.stringify(_.extend(t, paramObj, {id: id/*, comefrom: comefrom*/}));
            t = _.AESmodel().encryptURI(t);
            if(isApp === "android"){
                window.demo.saveParams('article_detail.html', ['t=', t, "&cn=", SCAddress].join(""))
                // window.open("article_detail.html");
            }else {
                window.open("article_detail.html?t=" + t + "&cn="+SCAddress);
            }  
        }
    })

    views.News = views.List.extend({
        tagName: "ul",
        className: "news",
        insertEL: function(){
            if($(".list ul.news").length < 1){
                this.$el.appendTo(".list").show();
                return;
            }
            if(this.$el.find("li").length < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.$el.show();
        },
        getNews: function(ops, offset){
            Net.NewsTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            offset = offset || 0;
            var datas = (data && data.NewsTitile && data.NewsTitile[0])||[] ,l = datas.length;
            for(var i = offset; i < l; i++){
                var datetime = datas[i].Time, date = datetime.substring(0, datetime.indexOf(" ")), time = datetime.substring(datetime.indexOf(" ") + 1);
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].ID;/* datas[i].comefrom =  datas[i].Author || "";*/
                this.$el.append(this.template(datas[i]));
            }
            this.offset = this.$el.find("li").length;
            if(this.offset < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.listenToEvents(this.$el.find("li"), this.tap, this.getDetail);
        }
    })

    views.Notices = views.List.extend({
        tagName: "ul",
        className: "notices",
        insertEL: function(){
            if($(".list ul.notices").length < 1){
                this.$el.appendTo(".list").show();
                return;
            }
            if(this.$el.find("li").length < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.$el.show();
        },
        getNews: function(ops, offset){            
            Net.BulletinTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            // console.log("返回数据：", data);
            offset = offset || 0;
            var datas = (data && data.BulletinTitile && data.BulletinTitile[0])||[] ,l = datas.length;
            for(var i = offset; i < l; i++){
                datas[i].Title = datas[i].BulletinTitle;
                var datetime = datas[i].PublishDate, date = datetime.substring(0, datetime.indexOf(" ")), time = datetime.substring(datetime.indexOf(" ") + 1, datetime.indexOf("."));
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].ID;/* datas[i].comefrom =  datas[i].CategoryName || "";*/
                this.$el.append(this.template(datas[i]));
            }
            this.$el.find(".time").hide();
            this.offset = this.$el.find("li").length;
            if(this.offset < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.listenToEvents(this.$el.find("li"), this.tap, this.getDetail);
        }
    })

    views.Reports = views.List.extend({
        tagName: "ul",
        className: "reports",
        insertEL: function(){
            if($(".list ul.reports").length < 1){
                this.$el.appendTo(".list").show();
                return;
            }
            if(this.$el.find("li").length < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.$el.show();      
        },
        getNews: function(ops, offset){
            Net.BSCTitle(ops, $.proxy(this.showNews, this, offset));
        },
        showNews: function(offset, data){
            // console.log("返回数据：", data);
            offset = offset || 0;
            var datas = (data && data.BSCTitle && data.BSCTitle[0])||[] ,l = datas.length;
            for(var i = offset; i < l; i++){
                var datetime = datas[i].Time, date = datetime.substring(0, datetime.indexOf(" ")), time = datetime.substring(datetime.indexOf(" ") + 1, datetime.indexOf("."));
                datas[i].date = date; datas[i].time = time; datas[i].id =  datas[i].GUID;/* datas[i].comefrom =  datas[i].OrgName || "";*/ 
                if(!datas[i].OrgName){
                    datas[i].Title = datas[i].Title;
                }else{
                    datas[i].Title = "【" + datas[i].OrgName + "】" + datas[i].Title;
                }
                this.$el.find(".time").hide();
                this.$el.append(this.template(datas[i]));
            }
            this.offset = this.$el.find("li").length;
            if(this.offset < 1){
                window.ShortTips.install("数据记录为0条");
                return;
            }
            this.listenToEvents(this.$el.find("li"), this.tap, this.getDetail);
        }
    })

    //个股诊断
    views.Diagnosis = views.baseView.extend({
        className: "diagnosis",
        init: function(ops){    
            $(".main-content > div").hide();   
            var flag = false, deferr = [];            
            if($(".main-content .diagnosis").length < 1){ 
                flag = true;
                this.$el.html(htmls.diag.join("")).appendTo(".main-content");                 
                this.bgcolor = this.$el.css("background-color"); 
                deferr.push(this.getGrade(ops));
                deferr.push(this.getPE(ops));
                deferr.push(this.getProfit(ops));
                deferr.push(this.getTrend(ops));    
                deferr = _.union(deferr, this.reFreshGraph(ops));           
            }
            var $this = this;
            $(window).off().resize(function(){
                var tmpWidth =  $this.$el.find(".data-graph:first-child").width();
                if(tmpWidth != $this.width && $(".main-content .diagnosis").is(":visible")){
                    $this.reFreshGraph(ops);
                }               
            });
            this.$el.show(); 
        },

        reFreshGraph: function(ops){
            this.width = this.$el.find(".data-graph:first-child").width() - 4;
            deferr5 = this.getGraphFund(ops);
            deferr6 = this.getGraphRank(ops);
            deferr7 = this.getGraphProfit(ops);
            deferr8 = this.getGraphData(ops);
            return [deferr5, deferr6, deferr7, deferr8];
            // return [deferr5];
        },
        //等级评级
        getGrade: function(ops){
            var $this = this;
            if(this.GradeData){
                doGrade(this.GradeData);
                return null;
            }
            return Net.Grade(ops, function(data){           
                var datas = this.GradeData = (data && data.Grade && data.Grade[0] && data.Grade[0][0]) || {}
                doGrade(datas)
            });

            function doGrade(datas){
                datas.JGPM = "--", datas.FZKJ = "--";datas.date = datas.Chg_dt.replace(/-/, "").replace(/-/, ".").substring(4, 9);                
                $this.$el.find(".research-wrap").html(_.template(htmls.diag_research.join(""))(_.extend({}, {date: "--", QLMRRS: "--", MRRS: "--", GWRS: "--", SDJCRS: "--", MCRS: "--", ZHPJ: "--", JGCG: "--", JTPM: "--", ZHMBJ12: "--", Now: "--", ZGB: "--"}, datas)));
                var star = datas.Star || 0, floorStar, prestar = datas.Pre_Star || 0, preFloorStar,
                    starWrap = $(".lastestreport"), preStarWrap = $(".lastreport");
                star < 0 && (star = 0), star > 5 && (star = 5), floorStar = Math.floor(star);
                prestar < 0 && (prestar = 0), prestar > 5 && (prestar = 5), preFloorStar = Math.floor(star);     
                if(floorStar < star){starWrap.find(".star-five:eq(" + floorStar + ")").addClass("half");}
                starWrap.find(".star-five:gt(" + floorStar + ")").addClass("disable");   
                if(preFloorStar < prestar){preStarWrap.find(".star-five:eq(" + preFloorStar + ")").addClass("half");}
                preStarWrap.find(".star-five:gt(" + preFloorStar + ")").addClass("disable"); 
                function setPosition(){
                    var tmpdatas = ["强力买入", "买入", "观望", "适度减持", "卖出"], dw = $this.$el.find(".grade-entry-wrap .grade-entry").width();
                    $this.$el.find(".grade-entry-wrap").css({"left":(tmpdatas.indexOf(datas.ZHPJ || "观望") * 20 + 10) + "%", "margin-left": (0 - dw) / 2});  
                }
                setPosition();  
                $this.$el.find(".data-graph-1 .text").html(_.template(htmls.diag_datagraph1.join(""))(_.extend({}, {JJCG: "--", ZGB: "--", SQJJCG: "--"}, datas)));         
            }
        },
        //业绩排名
        getPE: function(ops){
            var $this = this;
            if(this.GradeData){
                doPE(this.PEData);
                return null;
            }
            return Net.PE(ops, function(data){
                var datas = this.PEData = (data && data.PE && data.PE[0] && data.PE[0][0]) || {};
                console.log("排名:", datas)
                doPE(datas);
            });

            function doPE(datas){
                $this.$el.find(".data-graph-2 .text").html(_.template(htmls.diag_datagraph2.join(""))(_.extend({}, {Ranking: "--", value_all: "--", ind_value_avg: "--", mak_value_avg: "--"}, datas)));
            }
        },
        //利润
        getProfit: function(ops){
            var $this = this;
            if(this.EPSData){
                doEPS(this.EPSData);
                return null;
            }
            return Net.EPS(ops, function(data){
                var datas = this.EPSData = (data && data.EPS && data.EPS[0] && data.EPS[0][0]) || {};
                // console.log("利润:", datas)
                doEPS(datas);
            });
            function doEPS(datas){
                $this.$el.find(".data-graph-3 .text").html(_.template(htmls.diag_datagraph3.join(""))(_.extend({}, {T_EPS: "--", T_grona_stk: "--", rank_T_grona_stk: "--", T_grona_ind: "--", T3_grona_stk: "--"}, datas)));
            }
        },
        getTrend: function(ops){
            var $this = this;
            if(this.GatherData){
                doGather(this.GatherData);
                return null;
            }
            return Net.Gather(ops, function(data){
                var datas = this.GatherData = (data && data.Gather && data.Gather[0] && data.Gather[0][0]) || {};
                // console.log("趋势:", datas)          
                doGather(datas);   
            });
            function doGather(datas){
                $this.$el.find(".data-graph-4 .text").html(_.template(htmls.diag_datagraph4.join(""))(_.extend({}, {YZZJL: "--", YZHYZJL: "--", YZSCZJL: "--"}, datas)));
                $this.$el.find(".data-graph-5 .text").html(_.template(htmls.diag_datagraph5.join(""))(_.extend({}, {YRZDF: "--", YRHSL: "--", YZZDF: "--", Weather: "--", DRCJL: "--", QYRCJL: "--", YZHYZDF: "--", YZSCZDF: "--"}, datas)));
            } 

        },
        getGraphFund: function(ops){
            var $this = this;
            if(this.FinanceGraphData){
                doFinance(this.FinanceGraphData);
                return null;
            }
            return Net.Finance(ops, function(reqdata){
                var datas = this.FinanceGraphData = (reqdata && reqdata.Finance && reqdata.Finance[0]);
                doFinance(datas);               
            });  
            function doFinance(datas){
                $("#chartFund").parents(".chart").show();
                var data = [],
                    data1 = [{   
                        name: [""],
                        value:[],
                        color:'#E4B553',
                        line_width:3
                    }], data2 = [{name: [""],
                        value:[],
                        color:'#7988B5',
                        line_width:2
                    }], swicthDate={Q1: "03/", Q2: "06/", Q3: "09/", Q4: "12/"};
                var max = _.toFixedn(datas[0].LTGB, 1), rmax = _.toFixedn(datas[0].JGCGBL, 1), tmp = 0, l, i, j;
                datas = _.sortBy(datas, function(ops){return ops.Rpt_yr.substring(2) + swicthDate[ops.Rpt_interval]}), l = datas.length, tmpdatas = [];
                for(i = 0; i < l; i++){
                    if(datas[i].Rpt_interval == "Q2" || datas[i].Rpt_interval == "Q4"){
                        tmpdatas.push(datas[i]);
                    };
                }
                l = tmpdatas.length, datas = tmpdatas; tmpdatas = null;
                for(i = 0; i < l; i++){
                    tmp = _.toFixedn(datas[i].LTGB, 1), j++;
                    data.push({
                        name: ((l >= 5 && i % 2 == 1) ? "":(swicthDate[datas[i].Rpt_interval] + datas[i].Rpt_yr.substring(2))), 
                        value: tmp,
                        color: '#3298AE'
                    });
                    data[data.length]
                    if(max < tmp) max = tmp;
                    tmp = _.toFixedn(datas[i].JGCG, 1);
                    if(max < tmp) max = tmp;
                    data2[0].value.push(tmp);
                    tmp = _.toFixedn(datas[i].JGCGBL, 1);
                    data1[0].value.push(tmp);
                    if(rmax < tmp) rmax = tmp;                  
                }   
                max = _.RegAddOne(max); 
                rmax = _.RegAddOne(rmax);
                var dv1 = data1[0].value, dv2 = data2[0].value;
                if(dv1.length > 1 && dv2.length > 1){
                    dv1.splice(0, 0, Math.min(Math.max((dv1[0]*4 - dv1[1])/3, 0), rmax));
                    dv1.push(Math.min(Math.max((dv1[dv1.length-1]*4 - dv1[dv1.length-2])/3, 0), rmax));
                    dv2.splice(0, 0, Math.min(Math.max((dv2[0]*4 - dv2[1])/3, 0), max));
                    dv2.push(Math.min(Math.max((dv2[dv2.length-1]*4 - dv2[dv2.length-2])/3, 0), max));
                }              
                var label =  {
                        fontsize:11,
                        fontweight:600,
                        color: '#FFF'
                    };      
                var chart = new iChart.Column2D({
                    render : 'chartFund',
                    data : data,           
                    width : $this.width,
                    height : 200,
                    padding: "10 50 40 50",
                    label : _.extend({},label,{/*rotate:-45,*/offsety: 10}),        
                    background_color : null,
                    column_width : $this.width / 25,                   
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    sub_option : {
                        label : false,
                    },                  
                    border: {
                        width: 0
                    },
                    coordinate : {
                        axis : {
                            width : 0
                        },
                        width: "100%",   
                        grid_color:"#333",                           
                        scale : [{
                            position : 'left',
                            label : label,
                            start_scale: 0,
                            end_scale: max   
                        }],
                        zdy: true
                    }
                });
                //构造折线图
                var line = new iChart.LineBasic2D({
                    z_index:1000,
                    data: data1,           
                    point_space:chart.get('column_width')+chart.get('column_space'),
                    scaleAlign : 'right',
                    sub_option : {
                        label:false,
                        point_size:18,        
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    legend : {
                        border: {
                            width: 0
                        }
                    },
                    coordinate : { 
                        axis : {
                            width : 0
                        },
                        width: "100%",     
                        grid_color:"#333",   
                        grid_line_width: 0,               
                        scale : [{
                            position : 'right',
                            label : label,
                            start_scale: 0,
                            end_scale: rmax,
                            scale_enable: false,
                            listeners:{
                                parseText:function(t,x,y){
                                    return {text:t+"%"}
                                }
                            }   
                        }],
                        zdy: true
                    }                
                });
                //区域图
                var area = new iChart.Area2D({
                    data: data2,           
                    point_space:chart.get('column_width')+chart.get('column_space'),
                    scaleAlign : 'left',
                    sub_option : {
                        label:false,
                        point_size:0           
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    coordinate:chart.coo
                });
                chart.plugin(line);
                chart.plugin(area);
                chart.draw();
            }      
        },
        getGraphRank: function(ops){
            var $this = this;
            if(this.IndHistData){
                doIndHist(this.IndHistData);
                return null;
            }
            return Net.IndHist(ops, function(reqdata){
                var datas = this.IndHistData = reqdata && reqdata.IndHist && reqdata.IndHist[0];
                doIndHist(datas);
            })  
            function doIndHist(datas){
                $("#chartRank").parents(".chart").show();
                var data = [],data1 = [{   
                        name: [""],
                        value:[],
                        color:'#AA1354',
                        line_width:3
                    }], data2 = [{   name: [""],
                        value:[],
                        color:'#8DE5A5',
                        line_width:2
                    }];
                datas = _.sortBy(datas, function(ops){return ops.Qotdate.substring(2, 10)});
                var max = 0, tmpNum = 0, l = datas.length, i;
                for(i = 0; i < l; i++){
                    tmpNum = _.toFixedn(datas[i].F2S01, 1);
                    data.push({
                        name: ((l >= 5 && i % 2 == 1) ? "":datas[i].Qotdate.substring(5, 7) + "/" + datas[i].Qotdate.substring(2, 4)),
                        value: tmpNum,
                        color: '#3298AE'
                    });
                    if(parseFloat(max) < parseFloat(tmpNum)) max = tmpNum;
                    tmpNum =  _.toFixedn(datas[i].Hy_Avg, 1);
                    if(parseFloat(max) < parseFloat(tmpNum)) max = tmpNum;
                    data1[0].value.push(tmpNum); 
                    tmpNum =  _.toFixedn(datas[i].Sc_Avg, 1);
                    if(parseFloat(max) < parseFloat(tmpNum)) max = tmpNum;           
                    data2[0].value.push(tmpNum);               
                }                     
                max = _.RegAddOne(max);

                var dv1 = data1[0].value, dv2 = data2[0].value;
                if(dv1.length > 1 && dv2.length > 1){
                    dv1.splice(0, 0, Math.min(Math.max((dv1[0]*4 - dv1[1])/3, 0), max));
                    dv1.push(Math.min(Math.max((dv1[dv1.length-1]*4 - dv1[dv1.length-2])/3, 0), max));
                    dv2.splice(0, 0, Math.min(Math.max((dv2[0]*4 - dv2[1])/3, 0), max));
                    dv2.push(Math.min(Math.max((dv2[dv2.length-1]*4 - dv2[dv2.length-2])/3, 0), max));
                }
                
                var label =  {
                    fontsize:11,
                    fontweight:600,
                    color: '#FFF'
                };     
                            
                var chart = new iChart.Column2D({
                    render : 'chartRank',
                    data: data,
                    width : $this.width,
                    height : 200,
                    label : _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                    background_color : null,
                    padding: "10 50 40 50",
                    column_width : $this.width / 25,
                    border: {
                        width: 0
                    },
                    sub_option : {
                        label : false,
                    }, 
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    coordinate:{  
                        axis : {
                            width : 0
                        },  
                        width: "100%", 
                        grid_color:"#333",                             
                        scale:[{
                             label:label,
                             position:'left',
                             start_scale: 0,
                             end_scale: max                      
                        }],
                        zdy: true
                    },                  
                });
                var line1 = new iChart.LineBasic2D({
                    z_index:1000,
                    data: data1,           
                    point_space:chart.get('column_width')+chart.get('column_space'),
                    scaleAlign : 'left',
                    sub_option : {
                        label:false,
                        point_size:0
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    coordinate:chart.coo
                });
                var line2 = new iChart.LineBasic2D({
                    z_index:1000,
                    data: data2,           
                    point_space:chart.get('column_width')+chart.get('column_space'),
                    scaleAlign : 'left',
                    sub_option : {
                        label:false,
                        point_size:0
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    coordinate:chart.coo
                });
                
                chart.plugin(line1);
                chart.plugin(line2);                
                chart.draw(); 
            }      
        },
        getGraphProfit: function(ops){
            var $this = this;
            if(this.ForecastData){
                doForecast(this.ForecastData);
                return null;
            }
            return Net.Forecast(ops, function(reqdata){
                var datas = reqdata && reqdata.Forecast && reqdata.Forecast[0];
                doForecast(datas);         
            });
            function doForecast(datas){
                $("#chartProfit").parents(".chart").show();
                var data = [{
                    name : '',
                    value:[],
                    color:'#67C692',
                    line_width:2
                },{
                    name : '',
                    value:[],
                    color:'#DC4E21',
                    line_width:2
                }], data1 = [{
                    name : '',
                    value:[],
                    color:'#E4B553',
                    line_width:2
                }],swicthDate={Q1: "-03-31", Q2: "-06-30", Q3: "-09-30", Q4: "-12-31"},  labels = [];
                datas = _.sortBy(datas, function(ops){return ops.F1200/*.substring(2) + swicthDate[ops.Rpt_interval]*/});
                var l = datas.length, i;
                l > 5 && (l = 5);
                for(i = 0; i < l; i++){
                    data[1].value.push(_.toFixedn(datas[i].JJCGBL, 1)); 
                    data1[0].value.push(_.toFixedn(datas[i].JJCG, 1));               
                } 
                
                labels.push(datas[l-1].F1200-4);  
                labels.push(datas[l-1].F1200-3);  
                labels.push(datas[l-1].F1200-2);  
                labels.push(datas[l-1].F1200-1);  
                labels.push(datas[l-1].F1200);  
                data[0].value.push(_.toFixedn(datas[0].F223B || 0, 1));   
                data[0].value.push(_.toFixedn(datas[0].F223A || 0, 1)); 
                data[0].value.push(_.toFixedn(datas[0].F2237 || 0, 1)); 
                data[0].value.push(_.toFixedn(datas[0].F2236 || 0, 1)); 
                data[0].value.push(_.toFixedn(datas[0].F2230 || 0, 1));
                var label =  {
                    fontsize:11,
                    fontweight:600,
                    color: '#FFF'
                };  


                var chart = new iChart.LineBasic2D({
                    render : 'chartProfit',
                    data: data,
                    align:'center',
                    width : $this.width,
                    height : 200,
                    label: _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                    padding: "10 50 40 50",
                    background_color:null,            
                    border:{
                        width:0
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    legend : {
                        enable : true,
                        background_color:null,//设置透明背景
                        offsetx:10,//设置x轴偏移，满足位置需要
                        border : true
                    },
                    sub_option : {
                        label:false,
                        point_hollow : false,
                        point_size:0       
                    },
                    coordinate:{
                        axis : {
                            width : 0
                        },
                        width: "100%", 
                        grid_color:"#333", 
                        scale:[{
                             label: label,
                             position:'left',   
                             scale_color:'#9f9f9f',
                             listeners:{
                                parseText:function(t,x,y){
                                    return {text:t+"%"}
                                }
                            },
                        },{
                             label: label,
                             position:'bottom', 
                             labels:labels,
                             label: _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                        }]
                    }
                });

                var line = new iChart.LineBasic2D({
                    z_index:1000,
                    data: data1,           
                    point_space:chart.get('column_width')+chart.get('column_space'),
                    scaleAlign : 'left',
                    sub_option : {
                        label:false,
                        point_size:0
                    },
                    tip:{
                        enable:true,
                        onlyShowText: true
                    },
                    coordinate:{
                        axis : {
                            width : 0
                        },
                        width: "100%", 
                        grid_color:"#333", 
                        grid_line_width: 0,
                        scale:[{
                             label: label,
                             position:'right',   
                             scale_color:'#9f9f9f'                        
                        }]
                    }
                });
            
                //开始画图
                chart.plugin(line);
                chart.draw(); 
            }
        },
        getGraphData: function(ops){
            var $this = this;
            if(this.ZJLXData){
                doZJLX(this.ZJLXData);
                return null;
            }
            return Net.ZJLX(ops, function(serdata){
                var datas = serdata && serdata.ZJLX && serdata.ZJLX[0] && serdata.ZJLX[0][0];
                doZJLX(datas);
            }); 
            function doZJLX(datas){
                $this.getGraphTrend(datas);
                $this.getGraphMask(datas);  
            }     
        },
        getGraphTrend: function(datas){  
            var $this = this;
            $("#chartTrend").parents(".chart").show();
            var pv=[],ip=[],t;
            pv.push(_.toFixedn(datas.Rk_HY_2663), 1);pv.push(_.toFixedn(datas.Rk_HY_2662), 1);pv.push(_.toFixedn(datas.Rk_HY_2665), 1);pv.push(_.toFixedn(datas.Rk_HY_2661), 1);pv.push(_.toFixedn(datas.Rk_HY_2664), 1);pv.push(_.toFixedn(datas.Rk_HY_2660), 1);
            ip.push(_.toFixedn(datas.Rk_SC_2653), 1);ip.push(_.toFixedn(datas.Rk_SC_2652), 1);ip.push(_.toFixedn(datas.Rk_SC_2655), 1);ip.push(_.toFixedn(datas.Rk_SC_2651), 1);ip.push(_.toFixedn(datas.Rk_SC_2654), 1);ip.push(_.toFixedn(datas.Rk_SC_2650), 1);             
            var data = [
                {
                    name: "",
                    value:pv,
                    color:'#67C692',
                    line_width:2
                },
                {
                    name: "",
                    value:ip,
                    color:'#E4B553',
                    line_width:2
                }],
                label =  {
                    fontsize:11,
                    fontweight:600,
                    color: '#FFF'
                },               
                labels = ["近半年","近3月","上1月","近1月","上1周","近1周"],
                line = new iChart.LineBasic2D({
                render : 'chartTrend',
                data: data,
                align:'center',
                width : $this.width,
                height : 200,
                label: _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                padding: "10 50 40 50",
                background_color:null,            
                border:{
                    width:0
                },
                tip:{
                    enable:true,
                    onlyShowText: true
                },
                legend : {
                    enable : true,
                    row:1,//设置在一行上显示，与column配合使用
                    column : 'max',
                    valign:'top',
                    sign:'bar',
                    background_color:null,//设置透明背景
                    offsetx:-80,//设置x轴偏移，满足位置需要
                    border : true
                },
                sub_option : {
                    label:false,
                    point_hollow : false,
                    point_size:0   
                },
                coordinate:{
                    axis : {
                        width : 0
                    },
                    width: "100%", 
                    grid_color:"#333", 
                    scale:[{
                         label: label,
                         position:'left',   
                         scale_size:2,
                         scale_color:'#9f9f9f',
                    },{
                         label: label,
                         position:'bottom', 
                         labels:labels,
                         label: _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                    }]
                }
            });    
            //开始画图
            line.draw();   
        },   
        getGraphMask: function(datas){
            var $this = this;
            $("#chartMask").parents(".chart").show();
            var data = [
                        {name : '近一年',value : _.toFixedn(datas.ZDF_2614 - datas.HS300_ZDF_8114, 1),color : '#C13939'},
                        {name : '近半年',value : _.toFixedn(datas.ZDF_2613 - datas.HS300_ZDF_8113, 1),color : '#C13939'},
                        {name : '近三月',value : _.toFixedn(datas.ZDF_2612 - datas.HS300_ZDF_8112, 1),color : '#C13939'},
                        {name : '近一月',value : _.toFixedn(datas.ZDF_2611 - datas.HS300_ZDF_8111, 1),color : '#C13939'},
                        {name : '近一周',value : _.toFixedn(datas.ZDF_2610 - datas.HS300_ZDF_8110, 1),color : '#C13939'}
                    ],
                min = _.min(data, function(ops){return parseFloat(ops.value)}), max = _.max(data, function(ops){return parseFloat(ops.value)}),     
                minValue = _.RegAddOne(Math.abs(min.value) / 5) * ((min.value < 0) ? -1 : 1) * 5, 
                maxValue = _.RegAddOne(Math.abs(max.value) / 5) * ((max.value < 0) ? -1 : 1) * 5,       
                data1 = [
                            {
                                name:[""],
                                value:[_.toFixedn(datas.Rk_HY_2664, 1), _.toFixedn(datas.Rk_HY_2663, 1), _.toFixedn(datas.Rk_HY_2662, 1), _.toFixedn(datas.Rk_HY_2661, 1), _.toFixedn(datas.Rk_HY_2660, 1)],
                                color:'#4E9C75',
                                line_width:3
                            }
                       ],
                data2 = [
                            {
                                name:[""],
                                value:[_.toFixedn(datas.Rk_SC_2654, 1), _.toFixedn(datas.Rk_SC_2653, 1), _.toFixedn(datas.Rk_SC_2652, 1), _.toFixedn(datas.Rk_SC_2651, 1), _.toFixedn(datas.Rk_SC_2650, 1)],
                                color:'#EFB857',
                                line_width:3
                            }
                       ],
                dv1 = data1[0].value, dv2 = data2[0].value;
            dv1.splice(0, 0, (dv1[0]*4 - dv1[1])/3);
            dv1.push((dv1[dv1.length-1]*4 - dv1[dv1.length-2])/3);
            dv2.splice(0, 0, (dv2[0]*4 - dv2[1])/3);
            dv2.push((dv2[dv2.length-1]*4 - dv2[dv2.length-2])/3); 
            var label =  {
                    fontsize:11,
                    fontweight:600,
                    color: '#FFFFFF',
                    // gradient: false,
                    font: "微软雅黑"
                };    
            var chart = new iChart.Column2D({
                render : 'chartMask',
                data : data,           
                width : $this.width,
                height : 200,
                padding:10,
                label : _.extend({},label,{/*rotate:-45,*/offsety: 10}),
                padding: "10 50 40 50",
                background_color : null,
                column_width : $this.width / 25,
                tip:{
                    enable:true,
                    onlyShowText: true
                },
                sub_option : {
                    label : false,
                },                  
                border: {
                    width: 0
                },
                coordinate : {
                    axis : {
                        width : 1
                    },  
                    width: "100%",  
                    grid_color:"#333",                       
                    scale : [{
                        position:'right',  
                        label:label,
                        //scale_space: step,
                        start_scale: minValue,
                        end_scale: maxValue,
                        shadow: false,
                        listeners:{
                            parseText:function(t,x,y){
                                return {text:t+"%"}
                                // return {text:10}
                            }
                        },
                    }],
                    zdy: true
                }
            });
            //构造折线图
            var line = new iChart.LineBasic2D({
                z_index:1000,
                data: data1,           
                point_space:chart.get('column_width')+chart.get('column_space'),
                scaleAlign : 'right',
                sub_option : {
                    label:false,
                    point_size:0 
                },
                tip:{
                    enable:true,
                    onlyShowText: true
                },
                coordinate:{
                    axis : {
                        width : 0
                    },
                    background_color: null,
                    grid_line_width: 0,
                    width: "100%", 
                    grid_color:null,
                    scale:{
                        label: null
                    }

                }
            });
            //
            var line1 = new iChart.LineBasic2D({
                data: data2,  
                z_index:1000,         
                point_space:chart.get('column_width')+chart.get('column_space'),
                scaleAlign : 'right',
                sub_option : {
                    label:false,
                    point_size:0            
                },
                tip:{
                    enable:true,
                    onlyShowText: true
                },
                coordinate:{
                    axis : {
                        width : 0
                    },
                    grid_line_width: 0,
                    width: "100%", 
                    grid_color:null,
                    scale:{
                        label: null
                    }
                }
            });
            chart.plugin(new iChart.Custom({
                    drawFn:function(){
                        /**
                         *计算平均值的高度(坐标Y值)
                         */ 
                        var avg = 0,
                            coo = chart.getCoordinate(),
                            x = coo.get('originx'),
                            W = coo.width,
                            S = coo.getScale('left'),
                            H = coo.height,

                            h = (avg - S.end + Math.round(S.end/(1-S.basic))) * H / S.distance,
                            y = chart.y + H - h;
                        chart.target.line(x,y,x+W,y,2,'#FFF')
                        .textAlign('start')
                        .textBaseline('middle')
                        .textFont('600 12px Verdana')
                    }
            }));    
            chart.plugin(line);
            // chart.plugin(line1);
            chart.draw();       
        }
    })
})(); 
(function(){  
    //判断股票类型，显示不同的页面。
    Net.StockCategory({Code: code}, function(data){
        var datas = (data && data.StockCategory && data.StockCategory[0] && data.StockCategory[0][0]) || {},
            _stockKind = k_vCodeKind(datas.CategoryCode), type = paramObj.type, view;
        console.log(_stockKind);
        console.log(type);
        console.log(config.navs.length);
        config.navs = config.kinds[_stockKind];
        view = new views[config.navs[type].view](config.navs[type].ops, datas.SecuAbbr);
        // console.log("type: ", type)
        window.onunload = function() {
            Net.Log(config.navs[type].name + " 更多");
        };
    }) 
    function k_vCodeKind(tcode){
        var ecode = (tcode || "").substring(0, 3);
        switch(ecode){
            case "002":
                return "jj";
                break;
            case "003":
                if(tcode == "003004")
                    return "kzz";
                else
                    return "zq";
                break;
            case "004":
                return "hg";
                break;
            case "005":
                return "jj";
                break;
            default:
                return "gp";
                break; 
        }
    }
})();              
