var ServerID = "./"; //存放文件服务器地址
var nServer = "http://goldsunf10.guosen.cn/News/Service"; //协议服务器地址
var DOMAIN_NAME = "goldsunf10.guosen.cn"; // 通过dn传入的参数。

function dynamicLoadElement(parentElement, host, path, type){
    /* load css/script */
    var loadJavaScript = function(parent, host, path){
        var elem = document.createElement("script");
        elem.defer = true;
        elem.src = "http://" + host + path;
        parent.appendChild(elem);
        return elem;
    };
    var loadCss = function(parent, host, path){
        var elem = document.createElement("link");
        elem.rel = "stylesheet";
        elem.type = "text/css";
        elem.href = "http://" + host + path;
        //console.log(elem.href);
        parent.appendChild(elem);
        return elem;
    };
    if (arguments.length < 3){
        return;
    }
    if (typeof (type) == "undefined"){
        type = "javascript";
    }
    if (type == "css"){
        return loadCss(parentElement, host, path);
    } else if (type == "javascript"){
        return loadJavaScript(parentElement, host, path);
    }
}

function recursiveLoadJs(parentElement, host, files, error, done){
    if (files.length == 0){
        done();
        return;
    }
    var path = files.shift();
    var elem = document.createElement("script");
    elem.onload = elem.onreadystatechange = function(){
        recursiveLoadJs(parentElement, host, files, error, done);
    };
    elem.onerror = error;
    elem.defer = true;
    elem.src = "http://" + host + path;
    parentElement.appendChild(elem);
}

function getUrlParameters(){
    var reg = new RegExp("([^?&=#]+)=([^&=#?]+)", "igm");
    var url = window.location.href;
    var param = reg.exec(url);
    var result = {};
    while (param != null){
        result[param[1]] = param[2];
        param = reg.exec(url);
    }
    return result;
}

(function(){
    var host = getUrlParameters()["dn"];
    if (typeof (host) == "undefined"){
        host = DOMAIN_NAME;
    } else {
        DOMAIN_NAME = host;
    }
    var body = document.getElementsByTagName("body")[0];
    var head = document.getElementsByTagName("head")[0];
    ["/News/Html/Css/define-style.css", 
     // "/News/Html/Css/style.css"
    ].forEach(function(path){
        dynamicLoadElement(head, host, path, "css");
    });

    var jsFiles = [
        "/News/Html/Script/extend-underscore.js", 
        "/News/Html/Script/tipsBox.js", 
        "/News/Html/Script/Net/AES.js", 
        "/News/Html/Script/Net/Define.js", 
        "/News/Html/Script/Net/Net.js", 
        "/News/Html/Script/Config.js", 
        "/News/Html/Script/TPL.js", 
    ];
    nServer = ["http://", host, "/News/Service"].join("");

    var url = window.location.href;
    var extraJs = "";
    if (/finance_detail/.test(url)){
        extraJs = "/News/Html/Script/Views/financeView.js";
    } else if (/article_detail/.test(url)){
        extraJs = "/News/Html/Script/Views/articleView.js";
    } else if (/index\.html/.test(url)){
        extraJs = "/News/Html/Script/Views/Views.js";
    } else if (/list\.html/.test(url)){
        extraJs = "/News/Html/Script/Views/listView.js";
    }
    if (extraJs != ""){
        jsFiles.push(extraJs);
    }

    recursiveLoadJs(body, host, jsFiles, function(){
        window.demo.throwOutTime();
    }, function(){
    });
    var preOnLoad = window.onload;
    window.onload = function(){
        if (preOnLoad){
            preOnload();
        }
        var isApp = window.isApp;
        if(isApp =="android"){
            var height = $("body").height();
            window.demo.clickOnAndroid(height, $("body").css("background-color"));
            setTimeout(function(){
                var height = $("body").height();
                if (height == 0){
                    window.demo.throwOutTime();
                }
            }, 1000);
        } else if(isApp == "ios"){
            var url = "JSCommunicateOC/height:" + getHeight() + "?time=" + new Date().getTime();
            location.href = url;
        };
    };
})();
